"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var SingleStackedBar_exports = {};
__export(SingleStackedBar_exports, {
  DSSingleStackedBar: () => DSSingleStackedBar,
  DSSingleStackedBarWithSchema: () => DSSingleStackedBarWithSchema
});
module.exports = __toCommonJS(SingleStackedBar_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_ds_grid = require("@elliemae/ds-grid");
var import_ds_popperjs = require("@elliemae/ds-popperjs");
var import_ds_props_helpers = require("@elliemae/ds-props-helpers");
var import_ds_system = require("@elliemae/ds-system");
var import_react = __toESM(require("react"));
var import_colorPallet = require("../helpers/colorPallet.js");
var import_exported_related = require("./exported-related/index.js");
var import_react_desc_prop_types = require("./react-desc-prop-types.js");
var import_styles = require("./styles.js");
const Bar = import_react.default.memo((props) => {
  const [referenceElement, setReferenceElement] = (0, import_react.useState)(null);
  const [isHover, setIsHover] = (0, import_react.useState)(false);
  const { height, TooltipRenderer, datum, tabIndex, isFocused, borderRadius, bg } = props;
  const handleRefCallback = (0, import_react.useCallback)(
    (_ref) => {
      if (isFocused) {
        _ref?.focus();
      }
    },
    [isFocused]
  );
  const handleMouseEnter = (0, import_react.useCallback)(() => {
    setIsHover(true);
  }, []);
  const handleMouseLeave = (0, import_react.useCallback)(() => {
    setIsHover(false);
  }, []);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { children: [
    (isFocused || isHover) && TooltipRenderer ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ds_popperjs.DSPopperJS, { referenceElement, showPopover: true, children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_styles.StyledMouseOverDetectionBox, {}),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_styles.StyledTooltipContainer, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TooltipRenderer, { datum }) })
    ] }) : null,
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_styles.StyledBar,
      {
        onMouseEnter: handleMouseEnter,
        onMouseLeave: handleMouseLeave,
        bg,
        height,
        borderRadius,
        innerRef: (0, import_ds_system.mergeRefs)(handleRefCallback, setReferenceElement),
        tabIndex,
        role: "img",
        "aria-label": `${datum.name} value: ${datum.data}`
      }
    )
  ] });
});
const DSSingleStackedBar = (props) => {
  const propsWithDefaults = (0, import_ds_props_helpers.useMemoMergePropsWithDefault)(props, import_react_desc_prop_types.defaultProps);
  (0, import_ds_props_helpers.useValidateTypescriptPropTypes)(propsWithDefaults, import_react_desc_prop_types.DSSingleStackedBarPropTypes, "DSSingleStackedBar");
  const globalAttributes = (0, import_ds_props_helpers.useGetGlobalAttributes)(
    propsWithDefaults
  );
  const xstyledProps = (0, import_ds_props_helpers.useGetXstyledProps)(propsWithDefaults);
  const { data, LegendRenderer, gutter, height } = propsWithDefaults;
  const [keyBarFocused, setKeyBarFocused] = (0, import_react.useState)(0);
  const [isChartFocused, setIsChartFocused] = (0, import_react.useState)(false);
  const total = (0, import_react.useMemo)(() => data.map((datum) => datum.data).reduce((acc, curr) => acc + curr, 0), [data]);
  const cols = (0, import_react.useMemo)(() => data.map((datum) => `${Math.ceil(datum.data * 100) / total}%`), [data, total]);
  const rows = (0, import_react.useMemo)(
    () => LegendRenderer !== void 0 ? [`${height}px`, "auto"] : [`${height}px`],
    [LegendRenderer, height]
  );
  const barNames = (0, import_react.useMemo)(() => data.map((datum) => datum.name), [data]);
  const getBorderRadius = (0, import_react.useCallback)(
    (index) => {
      if (index === 0) return "50px 0 0 50px";
      if (index === data.length - 1) return "0 50px 50px 0";
      return void 0;
    },
    [data.length]
  );
  const handleOnKeyDown = (0, import_react.useCallback)(
    (e) => {
      if (e.code === "ArrowRight") {
        if (barNames[keyBarFocused + 1]) {
          setKeyBarFocused(keyBarFocused + 1);
        } else {
          setKeyBarFocused(0);
        }
      }
      if (e.code === "ArrowLeft") {
        if (barNames[keyBarFocused - 1]) {
          setKeyBarFocused(keyBarFocused - 1);
        } else {
          setKeyBarFocused(barNames.length - 1);
        }
      }
    },
    [keyBarFocused, barNames]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_styles.Wrapper,
    {
      cols,
      gutter,
      role: "region",
      onKeyDown: handleOnKeyDown,
      tabIndex: -1,
      onFocus: () => setIsChartFocused(true),
      onBlur: (e) => e.currentTarget !== e.target && setIsChartFocused(false),
      ...xstyledProps,
      ...globalAttributes,
      children: data.map((datum, i) => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_ds_grid.Grid, { rows, children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          Bar,
          {
            datum,
            isFocused: barNames[keyBarFocused] === datum.name && isChartFocused,
            borderRadius: getBorderRadius(i),
            bg: import_colorPallet.COLOR_PALLET[datum.color] ?? datum.color,
            tabIndex: i === keyBarFocused ? 0 : -1,
            ...props
          },
          datum.name
        ),
        LegendRenderer !== void 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(LegendRenderer, { datum }, `${datum.name}-legend`) : null
      ] }))
    }
  );
};
DSSingleStackedBar.displayName = import_exported_related.DSSingleStackedBarName;
const DSSingleStackedBarWithSchema = (0, import_ds_props_helpers.describe)(DSSingleStackedBar);
DSSingleStackedBarWithSchema.propTypes = import_react_desc_prop_types.DSSingleStackedBarPropTypes;
//# sourceMappingURL=SingleStackedBar.js.map
