"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useChart_exports = {};
__export(useChart_exports, {
  useChart: () => useChart
});
module.exports = __toCommonJS(useChart_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_uid = require("uid");
var import_lodash_es = require("lodash-es");
var import_resize_observer_polyfill = __toESM(require("resize-observer-polyfill"));
var import_react_desc_prop_types = require("../react-desc-prop-types.js");
var import_useScales = require("./useScales.js");
var import_helpers = require("../helpers/index.js");
var import_useInternalMargins = require("./useInternalMargins.js");
var import_useGetters = require("./useGetters.js");
var import_useValidateProps = require("./useValidateProps.js");
var import_colorPallet = require("../helpers/colorPallet.js");
const useResizeObserver = (ref) => {
  const [dimensions, setDimensions] = (0, import_react.useState)(0);
  (0, import_react.useEffect)(() => {
    if (ref) {
      const observeTarget = ref;
      const resizeObserver = new import_resize_observer_polyfill.default(
        (0, import_lodash_es.debounce)((entries) => {
          entries.forEach((entry) => {
            setDimensions(Math.ceil(entry.contentRect.width));
          });
        }, 200)
      );
      resizeObserver.observe(observeTarget);
      return () => {
        resizeObserver.unobserve(observeTarget);
      };
    }
    return () => {
    };
  }, [ref]);
  return dimensions;
};
const useChart = (props) => {
  (0, import_useValidateProps.useValidateProps)(props);
  const { series, yAxis, xAxis, width: userWidth, height: userHeight, groups: groupsStacked } = props;
  const userRatio = (0, import_react.useMemo)(
    () => props?.xAxis.advanced?.pointSpacing?.value ?? props?.yAxis.advanced?.pointSpacing?.value ?? 1,
    [props?.xAxis.advanced?.pointSpacing?.value, props?.yAxis.advanced?.pointSpacing?.value]
  );
  const originalSeries = (0, import_react.useMemo)(() => {
    if (series.length === 0) {
      return import_react_desc_prop_types.defaultProps.series;
    }
    return series;
  }, [series]);
  const [containerRef, setContainerRef] = (0, import_react.useState)(null);
  const dimensionWidth = useResizeObserver(containerRef);
  const width = (0, import_react.useMemo)(() => userWidth ?? dimensionWidth ?? 0, [dimensionWidth, userWidth]);
  const height = (0, import_react.useMemo)(() => userHeight ?? 500, [userHeight]);
  const [isGrabbed, setIsGrabbed] = (0, import_react.useState)(false);
  const [startPosition, setStartPosition] = (0, import_react.useState)(0);
  const [isZooming, setIsZooming] = (0, import_react.useState)(false);
  const [zoomStartingPosition, setZoomStartingPosition] = (0, import_react.useState)(0);
  const [movingPosition, setMovingPosition] = (0, import_react.useState)(0);
  const [activePoint, setActivePoint] = (0, import_react.useState)(null);
  const [activeSerie, setActiveSerie] = (0, import_react.useState)("");
  const [scrapperPosY, setScrapperPosY] = (0, import_react.useState)(-1);
  const [scrapperPosX, setScrapperPosX] = (0, import_react.useState)(-1);
  const [xScrollbarPosition, setXScrollbarPosition] = (0, import_react.useState)(0);
  const [isScrollbarVisible, setIsScrollbarVisible] = (0, import_react.useState)(false);
  const [containerRatio, setContainerRatio] = (0, import_react.useState)(userRatio);
  const lastScrollbarPosition = (0, import_react.useRef)(0);
  const [axisLeftRef, setAxisLeftRef] = (0, import_react.useState)(null);
  const [axisBottomRef, setAxisBottomRef] = (0, import_react.useState)(null);
  const [axisRightRef, setAxisRightRef] = (0, import_react.useState)(null);
  const [leftLegend, setLeftLegend] = (0, import_react.useState)(null);
  const [rightLegend, setRightLegend] = (0, import_react.useState)(null);
  const [topLegend, setTopLegend] = (0, import_react.useState)(null);
  const [bottomLegend, setBottomLegend] = (0, import_react.useState)(null);
  const [rightLabel, setRightLabel] = (0, import_react.useState)(null);
  const [leftLabel, setLeftLabel] = (0, import_react.useState)(null);
  const [bottomLabel, setBottomLabel] = (0, import_react.useState)(null);
  const [toolbarRef, setToolbarRef] = (0, import_react.useState)(null);
  (0, import_react.useEffect)(() => {
    lastScrollbarPosition.current = 0;
    setXScrollbarPosition(0);
  }, [dimensionWidth]);
  (0, import_react.useEffect)(() => {
    setContainerRatio(userRatio);
  }, [userRatio]);
  const {
    toolbarHeight,
    axisBottomHeight,
    axisRightWidth,
    bottomLabelHeight,
    internalMargin,
    leftLegendWidth,
    rightLabelWidth,
    leftLabelHeight,
    rightLegendHeight,
    bottomLegendWidth,
    leftLabelWidth,
    axisLeftWidth,
    topLegendHeight,
    leftLegendHeight
  } = (0, import_useInternalMargins.useInternalMargins)({
    axisLeftRef,
    axisBottomRef,
    axisRightRef,
    leftLabel,
    leftLegend,
    rightLegend,
    topLegend,
    bottomLegend,
    rightLabel,
    bottomLabel,
    toolbarRef
  });
  const innerWidth = (0, import_react.useMemo)(
    () => width - internalMargin.left - internalMargin.right,
    [internalMargin.left, internalMargin.right, width]
  );
  const innerHeight = (0, import_react.useMemo)(
    () => height - internalMargin.top - internalMargin.bottom,
    [internalMargin.top, internalMargin.bottom, height]
  );
  const [hiddenSeries, setHiddenSeries] = (0, import_react.useState)([]);
  const defaultScale = (0, import_react.useMemo)(() => {
    if (yAxis.type === "band") {
      return "x";
    }
    if ([void 0, "band"].includes(xAxis.type)) {
      return "y";
    }
    return "y";
  }, [xAxis.type, yAxis.type]);
  const [currentDataWithNullValues, currentData] = (0, import_react.useMemo)(() => {
    const baseData = originalSeries.filter((serie) => !hiddenSeries.includes(serie.name)).map((d, i) => ({
      ...d,
      // we set a default on the scale if the user do not pass it
      scale: d.scale || defaultScale,
      key: `${d.name}-${i}`,
      data: d.data.map((value, index) => ({
        key: `${d.name}-${i}-${index}`,
        value,
        position: index,
        serie: d.name,
        scale: d.scale,
        color: import_colorPallet.COLOR_PALLET[d.color] ?? d.color
      }))
    }));
    const currentDataWithoutNulls = baseData.map((data) => ({
      ...data,
      data: data.data.filter((datum) => datum.value !== null && datum.value !== void 0)
    }));
    return [baseData, currentDataWithoutNulls];
  }, [defaultScale, hiddenSeries, originalSeries]);
  const isHorizontal = (0, import_react.useMemo)(() => yAxis?.type === "band", [yAxis]);
  const { stackedData, scalesStackedDataMap } = (0, import_react.useMemo)(
    () => (0, import_helpers.stackData)(groupsStacked, originalSeries, hiddenSeries, isHorizontal),
    [groupsStacked, originalSeries, hiddenSeries, isHorizontal]
  );
  const groups = (0, import_react.useMemo)(() => currentData.map((serie) => serie.name), [currentData]);
  const { xScale, yScale, y2Scale, subGroupScale, colorScale, getBandwidth } = (0, import_useScales.useScales)({
    props,
    originalSeries,
    innerHeight,
    innerWidth,
    groups,
    stackedData,
    scalesStackedDataMap,
    currentData,
    containerRatio
  });
  const {
    getXValue,
    getY2ScaleValue,
    getYValue,
    getXScaleValue,
    getYScaleValue,
    getYValueFormatted,
    getXValueFormatted
  } = (0, import_useGetters.useGetters)({
    xAxis,
    yAxis,
    isHorizontal,
    xScale,
    yScale,
    y2Scale
  });
  const chartId = (0, import_react.useMemo)(() => (0, import_uid.uid)(6), []);
  return (0, import_react.useMemo)(
    () => ({
      props,
      originalSeries,
      isZooming,
      setIsZooming,
      zoomStartingPosition,
      setZoomStartingPosition,
      setMovingPosition,
      movingPosition,
      innerHeight,
      innerWidth,
      groups,
      currentData,
      colorScale,
      stackedData,
      subGroupScale,
      xScale,
      yScale,
      y2Scale,
      containerRef,
      getBandwidth,
      scrapperPosY,
      setScrapperPosY,
      scrapperPosX,
      setScrapperPosX,
      activePoint,
      setActivePoint,
      activeSerie,
      setActiveSerie,
      xScrollbarPosition,
      setXScrollbarPosition,
      isGrabbed,
      setIsGrabbed,
      setContainerRef,
      startPosition,
      setStartPosition,
      isScrollbarVisible,
      setIsScrollbarVisible,
      lastScrollbarPosition,
      containerRatio,
      internalMargin,
      axisLeftRef,
      leftLegendWidth,
      leftLegend,
      setAxisLeftRef,
      setLeftLegend,
      setRightLegend,
      rightLegend,
      setTopLegend,
      setBottomLegend,
      setAxisBottomRef,
      axisBottomHeight,
      setAxisRightRef,
      setRightLabel,
      setBottomLabel,
      getXScaleValue,
      getYScaleValue,
      getY2ScaleValue,
      getYValueFormatted,
      getXValueFormatted,
      bottomLabelHeight,
      rightLabelWidth,
      axisRightWidth,
      getXValue,
      getYValue,
      isHorizontal,
      setLeftLabel,
      leftLabel,
      chartId,
      hiddenSeries,
      setHiddenSeries,
      height,
      width,
      setContainerRatio,
      toolbarHeight,
      setToolbarRef,
      leftLabelHeight,
      rightLegendHeight,
      bottomLegendWidth,
      bottomLegend,
      leftLabelWidth,
      axisLeftWidth,
      topLegendHeight,
      leftLegendHeight,
      currentDataWithNullValues
    }),
    [
      props,
      originalSeries,
      isZooming,
      zoomStartingPosition,
      movingPosition,
      innerHeight,
      innerWidth,
      groups,
      currentData,
      colorScale,
      stackedData,
      subGroupScale,
      xScale,
      yScale,
      y2Scale,
      containerRef,
      getBandwidth,
      scrapperPosY,
      getY2ScaleValue,
      scrapperPosX,
      activePoint,
      activeSerie,
      xScrollbarPosition,
      isGrabbed,
      startPosition,
      isScrollbarVisible,
      containerRatio,
      internalMargin,
      axisLeftRef,
      leftLegendWidth,
      leftLegend,
      rightLegend,
      axisBottomHeight,
      getXScaleValue,
      getYScaleValue,
      getYValueFormatted,
      getXValueFormatted,
      bottomLabelHeight,
      rightLabelWidth,
      axisRightWidth,
      getXValue,
      getYValue,
      isHorizontal,
      leftLabel,
      chartId,
      hiddenSeries,
      height,
      width,
      toolbarHeight,
      leftLabelHeight,
      rightLegendHeight,
      bottomLegendWidth,
      bottomLegend,
      leftLabelWidth,
      axisLeftWidth,
      topLegendHeight,
      leftLegendHeight,
      currentDataWithNullValues
    ]
  );
};
//# sourceMappingURL=useChart.js.map
