"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useGetters_exports = {};
__export(useGetters_exports, {
  useGetters: () => useGetters
});
module.exports = __toCommonJS(useGetters_exports);
var React = __toESM(require("react"));
var import_react = require("react");
function isLinear(scale) {
  return scale.type !== "LINEAR";
}
function isBand(scale) {
  return scale.type !== "BAND";
}
function isTime(scale) {
  return scale.type !== "DATETIME";
}
function isValueT(value) {
  return typeof value === "number" || typeof value === "string" || value instanceof Date;
}
const useGetters = ({ xAxis, isHorizontal, yAxis, xScale, yScale, y2Scale }) => {
  const getXValue = (0, import_react.useCallback)(
    (datum) => {
      if (!datum) return null;
      if (!isHorizontal) {
        if (xAxis?.cols?.[datum.position]) {
          return xAxis?.cols?.[datum.position];
        }
        if (typeof datum.value === "object") return datum.value?.x;
        return datum.position.toString();
      }
      if (typeof datum.value === "number") {
        return datum.value;
      }
      return datum.value?.x;
    },
    [isHorizontal, xAxis?.cols]
  );
  const getYValue = (0, import_react.useCallback)(
    (datum) => {
      if (!datum) return null;
      if (!isHorizontal) {
        if (typeof datum.value === "number") {
          return datum.value;
        }
        return datum.value?.y;
      }
      if (yAxis?.cols?.[datum.position]) {
        return yAxis?.cols?.[datum.position];
      }
      if (typeof datum.value === "object") return datum.value?.y;
      return datum.position.toString();
    },
    [isHorizontal, yAxis?.cols]
  );
  const getXScaleValue = (0, import_react.useCallback)(
    (datum) => {
      if (isLinear(xScale)) {
        if (isValueT(datum)) return xScale?.get(datum);
        return xScale?.get(getXValue(datum));
      }
      if (isBand(xScale)) {
        if (isValueT(datum)) return xScale?.get(datum) ?? 0;
        return xScale?.get(getXValue(datum)) ?? 0;
      }
      if (isTime(xScale)) {
        if (isValueT(datum)) return xScale?.get(datum);
        return xScale?.get(new Date(getXValue(datum)));
      }
      return 0;
    },
    [getXValue, xScale]
  );
  const getYScaleValue = (0, import_react.useCallback)(
    (datum) => {
      if (isLinear(yScale)) {
        if (isValueT(datum)) return yScale?.get(datum);
        return yScale.get(getYValue(datum));
      }
      if (isBand(yScale)) {
        if (isValueT(datum)) return yScale?.get(datum) ?? 0;
        return yScale?.get(getYValue(datum)) ?? 0;
      }
      return 0;
    },
    [getYValue, yScale]
  );
  const getY2ScaleValue = (0, import_react.useCallback)(
    (datum) => {
      if (isLinear(y2Scale)) {
        if (isValueT(datum)) return y2Scale?.get(datum);
        return y2Scale.get(getYValue(datum));
      }
      if (isBand(y2Scale)) {
        if (isValueT(datum)) return y2Scale?.get(datum) ?? 0;
        return y2Scale?.get(getYValue(datum)) ?? 0;
      }
      return 0;
    },
    [getYValue, y2Scale]
  );
  const getYValueFormatted = (0, import_react.useCallback)(
    (datum) => {
      if (!datum) return null;
      const value = getYValue(datum);
      if (typeof yAxis.tick?.tickFormat === "function") return yAxis.tick.tickFormat(value);
      return value;
    },
    [getYValue, yAxis.tick]
  );
  const getXValueFormatted = (0, import_react.useCallback)(
    (datum) => {
      if (!datum) return null;
      const value = getXValue(datum);
      if (typeof xAxis.tick?.tickFormat === "function") return xAxis.tick.tickFormat(value);
      return value;
    },
    [getXValue, xAxis.tick]
  );
  return (0, import_react.useMemo)(
    () => ({
      getYValue,
      getY2ScaleValue,
      getXValue,
      getXScaleValue,
      getYScaleValue,
      getYValueFormatted,
      getXValueFormatted
    }),
    [getYValue, getXValue, getY2ScaleValue, getXScaleValue, getYScaleValue, getYValueFormatted, getXValueFormatted]
  );
};
//# sourceMappingURL=useGetters.js.map
