"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useInternalMargins_exports = {};
__export(useInternalMargins_exports, {
  useInternalMargins: () => useInternalMargins
});
module.exports = __toCommonJS(useInternalMargins_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_resize_observer_polyfill = __toESM(require("resize-observer-polyfill"));
const useResizeObserver = (ref, { offsetHeight = 0, offsetWidth = 0 } = { offsetHeight: 0, offsetWidth: 0 }) => {
  const [width, setWidth] = (0, import_react.useState)(0);
  const [height, setHeight] = (0, import_react.useState)(0);
  (0, import_react.useEffect)(() => {
    if (ref) {
      const observeTarget = ref;
      const resizeObserver = new import_resize_observer_polyfill.default((entries) => {
        entries.forEach((entry) => {
          setWidth(Math.ceil(entry.contentRect.width + offsetWidth));
          setHeight(Math.ceil(entry.contentRect.height + offsetHeight));
        });
      });
      resizeObserver.observe(observeTarget);
      return () => {
        resizeObserver.unobserve(observeTarget);
      };
    }
    return () => {
    };
  }, [offsetHeight, offsetWidth, ref]);
  return { width, height };
};
const useInternalMargins = ({
  axisLeftRef,
  axisBottomRef,
  axisRightRef,
  leftLabel,
  leftLegend,
  rightLegend,
  topLegend,
  bottomLegend,
  rightLabel,
  bottomLabel,
  toolbarRef
}) => {
  const { height: toolbarHeight } = useResizeObserver(toolbarRef, { offsetHeight: 10 });
  const { width: axisRightWidth } = useResizeObserver(axisRightRef, { offsetWidth: 10 });
  const { height: axisBottomHeight } = useResizeObserver(axisBottomRef, { offsetHeight: 20 });
  const { width: axisLeftWidth } = useResizeObserver(axisLeftRef, { offsetWidth: 10 });
  const { height: bottomLabelHeight } = useResizeObserver(bottomLabel, { offsetHeight: 10 });
  const { width: rightLabelWidth } = useResizeObserver(rightLabel, { offsetWidth: 10 });
  const { width: leftLabelWidth, height: leftLabelHeight } = useResizeObserver(leftLabel);
  const { height: topLegendHeight } = useResizeObserver(topLegend, { offsetHeight: 20 });
  const { height: bottomLegendHeight, width: bottomLegendWidth } = useResizeObserver(bottomLegend, {
    offsetHeight: 10
  });
  const { width: rightLegendWidth, height: rightLegendHeight } = useResizeObserver(rightLegend);
  const { width: leftLegendWidth, height: leftLegendHeight } = useResizeObserver(leftLegend, { offsetWidth: 20 });
  const internalMargin = (0, import_react.useMemo)(
    () => ({
      bottom: axisBottomHeight + bottomLegendHeight + bottomLabelHeight || 10,
      top: Math.max(topLegendHeight, toolbarHeight) || 10,
      right: rightLabelWidth + axisRightWidth + rightLegendWidth || 15,
      left: axisLeftWidth + leftLabelWidth + leftLegendWidth || 10
    }),
    [
      axisBottomHeight,
      bottomLegendHeight,
      bottomLabelHeight,
      topLegendHeight,
      toolbarHeight,
      rightLabelWidth,
      axisRightWidth,
      rightLegendWidth,
      axisLeftWidth,
      leftLabelWidth,
      leftLegendWidth
    ]
  );
  return (0, import_react.useMemo)(
    () => ({
      internalMargin,
      leftLegendHeight,
      leftLegendWidth,
      axisBottomHeight,
      bottomLegendHeight,
      bottomLabelHeight,
      topLegendHeight,
      rightLabelWidth,
      axisRightWidth,
      rightLegendWidth,
      axisLeftWidth,
      leftLabelWidth,
      toolbarHeight,
      leftLabelHeight,
      rightLegendHeight,
      bottomLegendWidth
    }),
    [
      axisBottomHeight,
      toolbarHeight,
      leftLegendHeight,
      axisLeftWidth,
      axisRightWidth,
      bottomLabelHeight,
      bottomLegendHeight,
      internalMargin,
      leftLabelWidth,
      leftLegendWidth,
      rightLabelWidth,
      rightLegendWidth,
      topLegendHeight,
      leftLabelHeight,
      rightLegendHeight,
      bottomLegendWidth
    ]
  );
};
//# sourceMappingURL=useInternalMargins.js.map
