"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useKeyboardNavigation_exports = {};
__export(useKeyboardNavigation_exports, {
  findInCircularList: () => findInCircularList,
  useKeyboardNavigation: () => useKeyboardNavigation
});
module.exports = __toCommonJS(useKeyboardNavigation_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
const findInCircularList = (list, from, step = 1, criteria = (item) => item !== void 0) => {
  for (let i = (from + step + list.length) % list.length; i !== from && from > -1; i = (i + step + list.length) % list.length) {
    if (list[i] && criteria(i)) {
      return i;
    }
  }
  return from;
};
const useKeyboardNavigation = () => {
  const {
    activePoint,
    setActivePoint,
    containerRef,
    xScale,
    yScale,
    lastScrollbarPosition,
    setXScrollbarPosition,
    containerRatio,
    xScrollbarPosition,
    innerWidth,
    innerHeight,
    getXScaleValue,
    getYScaleValue,
    groups,
    isZooming,
    setIsZooming,
    zoomStartingPosition,
    setZoomStartingPosition,
    setMovingPosition,
    setContainerRatio,
    currentDataWithNullValues,
    props: { xScroll, yScroll }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const currentSerie = (0, import_react.useMemo)(
    () => currentDataWithNullValues.find((d) => d.name === activePoint?.serie) ?? currentDataWithNullValues[0],
    [activePoint?.serie, currentDataWithNullValues]
  );
  const currentActiveItemIndex = (0, import_react.useMemo)(
    () => currentSerie?.data.findIndex((opt) => opt.key === activePoint?.key),
    [activePoint, currentSerie]
  );
  const listMap = (0, import_react.useMemo)(
    () => currentSerie?.data.map((d) => {
      if (typeof d.value === "object") return JSON.stringify(d.value);
      return d.value?.toString();
    }) ?? [],
    [currentSerie?.data]
  );
  const handleOnFocus = (0, import_react.useCallback)(
    (e) => {
      if (containerRef === e.target && activePoint === null) {
        setActivePoint(currentSerie?.data[0]);
        setXScrollbarPosition(0);
      }
    },
    [activePoint, containerRef, currentSerie?.data, setActivePoint, setXScrollbarPosition]
  );
  const handleOnBlur = (0, import_react.useCallback)(() => {
    setTimeout(() => {
      if (!containerRef?.contains(document.activeElement)) {
        setActivePoint(null);
      }
    });
  }, [setActivePoint, containerRef]);
  const navigateSerie = (0, import_react.useCallback)(
    (step) => {
      const newValue = findInCircularList(listMap, currentActiveItemIndex, step);
      setActivePoint(currentSerie?.data[newValue]);
      if (xScroll) {
        const xValue = getXScaleValue(currentSerie?.data[newValue]);
        if (xValue === void 0) return;
        const barWidth = innerWidth / containerRatio;
        const total = innerWidth * containerRatio;
        if (total <= xValue) {
          setXScrollbarPosition((total - innerWidth) / containerRatio);
        } else if (xValue > xScrollbarPosition * containerRatio + innerWidth)
          setXScrollbarPosition((prev) => {
            const nextPosition = prev + (xValue / containerRatio - prev);
            if (nextPosition + barWidth > innerWidth) return innerWidth - barWidth;
            return nextPosition;
          });
        else if (xValue < xScrollbarPosition * containerRatio) setXScrollbarPosition(xValue / containerRatio);
      } else if (yScroll) {
        const yValue = getYScaleValue(currentSerie?.data[newValue]);
        if (yValue === void 0) return;
        const barWidth = innerHeight / containerRatio;
        const total = innerHeight * containerRatio;
        if (total <= yValue) {
          setXScrollbarPosition((total - innerHeight) / containerRatio);
        } else if (yValue > xScrollbarPosition * containerRatio + innerHeight)
          setXScrollbarPosition((prev) => {
            const nextPosition = prev + (yValue / containerRatio - prev);
            if (nextPosition + barWidth > innerHeight) return innerHeight - barWidth;
            return nextPosition;
          });
        else if (yValue < xScrollbarPosition * containerRatio) setXScrollbarPosition(yValue / containerRatio);
      }
    },
    [
      listMap,
      currentActiveItemIndex,
      setActivePoint,
      currentSerie?.data,
      xScroll,
      yScroll,
      getXScaleValue,
      innerWidth,
      containerRatio,
      xScrollbarPosition,
      setXScrollbarPosition,
      getYScaleValue,
      innerHeight
    ]
  );
  const changeSerie = (0, import_react.useCallback)(
    (step) => {
      const nextSerieIndex = findInCircularList(
        groups,
        groups.findIndex((item) => item === currentSerie.name),
        step,
        (idx) => currentDataWithNullValues[idx].data[currentActiveItemIndex].value !== null
      );
      setActivePoint(currentDataWithNullValues[nextSerieIndex].data[currentActiveItemIndex]);
    },
    [groups, setActivePoint, currentActiveItemIndex, currentSerie.name, currentDataWithNullValues]
  );
  const onInputKeyDown = (0, import_react.useCallback)(
    (e) => {
      if (!activePoint) return;
      if (e.code !== "Tab") {
        e.preventDefault();
      }
      if (["ArrowLeft", "ArrowRight"].includes(e.code)) {
        if (yScale?.type === "BAND") changeSerie(e.code === "ArrowLeft" ? -1 : 1);
        else navigateSerie(e.code === "ArrowLeft" ? -1 : 1);
      }
      if (["ArrowDown", "ArrowUp"].includes(e.code)) {
        if (yScale?.type === "BAND") navigateSerie(e.code === "ArrowDown" ? 1 : -1);
        else changeSerie(e.code === "ArrowDown" ? -1 : 1);
      }
      const { code } = e;
      const isShiftKey = ["ShiftLeft", "ShiftRight"].includes(code);
      const xScaledActivePoint = getXScaleValue(activePoint);
      if (isShiftKey && !isZooming && xScale?.type !== "BAND" && xScaledActivePoint) {
        setIsZooming(true);
        setZoomStartingPosition(xScaledActivePoint - xScrollbarPosition * containerRatio);
      }
    },
    [
      activePoint,
      changeSerie,
      containerRatio,
      getXScaleValue,
      isZooming,
      navigateSerie,
      setIsZooming,
      setZoomStartingPosition,
      xScale?.type,
      xScrollbarPosition,
      yScale?.type
    ]
  );
  const handleOnKeyUp = (0, import_react.useCallback)(
    (e) => {
      if (!activePoint) return;
      if (!isZooming && xScale?.type === "BAND") return;
      const { shiftKey, code } = e;
      const isShiftKey = ["ShiftLeft", "ShiftRight"].includes(code);
      const xScaledActivePoint = getXScaleValue(activePoint);
      if (shiftKey && ["ArrowRight", "ArrowLeft"].includes(code) && xScaledActivePoint) {
        setMovingPosition(xScaledActivePoint - xScrollbarPosition * containerRatio);
      }
      if (isShiftKey && xScaledActivePoint) {
        setIsZooming(false);
        setZoomStartingPosition(0);
        setMovingPosition(0);
        const endingPosition = xScaledActivePoint - xScrollbarPosition * containerRatio;
        const isRightDirection = zoomStartingPosition < endingPosition;
        const offsetActivePoint = findInCircularList(listMap, currentActiveItemIndex, isRightDirection ? 1 : -1);
        const offSetXScaledActivePoint = getXScaleValue(currentSerie?.data[offsetActivePoint]);
        const correctEndingPosition = offSetXScaledActivePoint ?? 0 - xScrollbarPosition * containerRatio;
        const diff = Math.abs(zoomStartingPosition - correctEndingPosition);
        if (diff <= 0) return;
        const newRatio = innerWidth / (innerWidth * containerRatio / diff) < 40 ? innerWidth / 40 : innerWidth * containerRatio / diff;
        const newPosition = lastScrollbarPosition.current + (!isRightDirection ? correctEndingPosition : zoomStartingPosition) / containerRatio;
        if (newPosition > innerWidth - innerWidth / newRatio) setXScrollbarPosition(innerWidth - innerWidth / newRatio);
        else setXScrollbarPosition(newPosition);
        setActivePoint(null);
        setTimeout(() => setActivePoint(activePoint));
        setContainerRatio(newRatio);
        lastScrollbarPosition.current = newPosition;
      }
    },
    [
      activePoint,
      containerRatio,
      currentActiveItemIndex,
      currentSerie?.data,
      getXScaleValue,
      innerWidth,
      isZooming,
      lastScrollbarPosition,
      listMap,
      setActivePoint,
      setContainerRatio,
      setIsZooming,
      setMovingPosition,
      setXScrollbarPosition,
      setZoomStartingPosition,
      xScale?.type,
      xScrollbarPosition,
      zoomStartingPosition
    ]
  );
  return (0, import_react.useMemo)(
    () => ({ handleOnKeyUp, onInputKeyDown, handleOnBlur, handleOnFocus }),
    [handleOnBlur, handleOnFocus, handleOnKeyUp, onInputKeyDown]
  );
};
//# sourceMappingURL=useKeyboardNavigation.js.map
