"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useScales_exports = {};
__export(useScales_exports, {
  useScales: () => useScales
});
module.exports = __toCommonJS(useScales_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_d3 = require("d3");
var import_helpers = require("../helpers/index.js");
var import_colorPallet = require("../helpers/colorPallet.js");
var import_constants = require("../../constants.js");
var import_scales = require("../scales/index.js");
const useScales = ({
  props,
  originalSeries: series,
  innerHeight,
  innerWidth,
  stackedData,
  currentData,
  scalesStackedDataMap,
  containerRatio
}) => {
  const { xAxis, yAxis, y2Axis, groups: stackedSeries, xScroll, yScroll } = props;
  const getBandDomain = (0, import_react.useCallback)(
    (axis) => axis.cols ?? [...series[0].data.map((_, i) => i.toString())],
    [series]
  );
  const getPadding = (domainPadding) => typeof domainPadding === "number" ? [domainPadding, domainPadding] : domainPadding ?? [0, 0];
  const getLinearDomain = (0, import_react.useCallback)(
    (axis, axisString) => {
      const begin = axis?.beginAtZero ? 0 : axis.min ?? void 0;
      const end = axis.max ?? void 0;
      const data = currentData.filter((serie) => serie.scale === axisString || axisString === "x").map(
        (serie) => serie.data.filter((datum) => datum.value !== null).map((datum) => {
          if (typeof datum.value === "number") {
            return datum.value;
          }
          return datum.value[axisString === "y2" ? "y" : axisString];
        })
      );
      const dataFlattened = data.flat();
      const stackedDataFlatten = stackedData.filter((_, i) => scalesStackedDataMap[i] === axisString).flat();
      const minStackedData = (0, import_d3.min)(stackedDataFlatten, (layer) => (0, import_d3.min)(layer, (sequence) => sequence[0]));
      const maxStackedData = (0, import_d3.max)(stackedDataFlatten, (layer) => (0, import_d3.max)(layer, (sequence) => sequence[1]));
      const minData = (0, import_d3.min)(dataFlattened);
      const maxData = (0, import_d3.max)(dataFlattened);
      const types = ["number", "object"];
      const getMin = () => {
        const aux = [];
        if (typeof begin === "number" || typeof begin === "object") aux.push(begin);
        if (types.includes(typeof minData) && minData !== void 0) aux.push(minData);
        if (typeof minStackedData === "number") aux.push(minStackedData);
        return (0, import_d3.min)(aux);
      };
      const getMax = () => {
        const aux = [];
        if (typeof begin === "number" || typeof begin === "object") aux.push(begin);
        if (typeof end === "number" || typeof end === "object") aux.push(end);
        if (types.includes(typeof maxData) && maxData !== void 0) aux.push(maxData);
        if (typeof maxStackedData === "number") aux.push(maxStackedData);
        return (0, import_d3.max)(aux);
      };
      const minRange = getMin();
      const maxRange = getMax();
      const [leftPadding, rightPadding] = getPadding(axis.domainPadding);
      if (typeof minRange === "number" && typeof maxRange === "number") {
        return [
          minRange - (maxRange - minRange) * (leftPadding ?? 0),
          maxRange + (maxRange - minRange) * (rightPadding ?? 0)
        ];
      }
      if (typeof minRange === "object" && typeof maxRange === "object") {
        if (axis.domainPaddingType && import_constants.TIME_OFFSET[axis.domainPaddingType]) {
          return [
            import_constants.TIME_OFFSET[axis.domainPaddingType].offset(minRange, -leftPadding),
            import_constants.TIME_OFFSET[axis.domainPaddingType].offset(maxRange, rightPadding)
          ];
        }
        return [minRange, maxRange];
      }
      return [];
    },
    [currentData, scalesStackedDataMap, stackedData]
  );
  const getScaleTime = (domain, range) => (0, import_d3.scaleUtc)().domain(domain).range(range);
  const getScaleBand = (domain, range, padding = 0.2) => (0, import_d3.scaleBand)().domain(domain).range(range).padding(padding).paddingOuter(0.05);
  const getScaleLinear = (domain, range) => (0, import_d3.scaleLinear)().domain(domain).range(range);
  const getScaleLog = (domain, range) => (0, import_d3.scaleLog)().domain(domain).range(range);
  const scaleFactory = (0, import_react.useCallback)(
    (axis, axisProps, range = []) => {
      if (!axisProps) return null;
      if (["time", "datetime"].includes(axisProps?.type)) {
        return new import_scales.TimeLinearScale(getScaleTime(getLinearDomain(axisProps, axis), range), axisProps);
      }
      if (axisProps?.type === "linear" || ["y", "y2"].includes(axis) && axisProps?.type === void 0) {
        return new import_scales.LinearScale(getScaleLinear(getLinearDomain(axisProps, axis), range), axisProps);
      }
      if (axisProps?.type === "log")
        return new import_scales.LogScale(getScaleLog(getLinearDomain(axisProps, axis), range), axisProps);
      if (axisProps?.type === "band" || axis === "x" && axisProps?.type === void 0) {
        const realRange = axis === "y" ? range.reverse() : range;
        return new import_scales.BandScale(getScaleBand(getBandDomain(axisProps), realRange), axisProps);
      }
      return null;
    },
    [getBandDomain, getLinearDomain]
  );
  const xRangeFrom = (0, import_react.useMemo)(() => containerRatio * (xAxis?.plotRange?.[0] || 0), [containerRatio, xAxis?.plotRange]);
  const xRangeTo = (0, import_react.useMemo)(
    () => (innerWidth - (xAxis?.plotRange?.[1] || 0)) * (xScroll ? containerRatio : 1),
    [containerRatio, innerWidth, xAxis?.plotRange, xScroll]
  );
  const yRangeTo = (0, import_react.useMemo)(() => yAxis?.plotRange?.[0] || 0, [yAxis?.plotRange]);
  const yRangeFrom = (0, import_react.useMemo)(
    () => (innerHeight - (yAxis?.plotRange?.[1] || 0)) * (yScroll ? containerRatio : 1),
    [containerRatio, innerHeight, yAxis?.plotRange, yScroll]
  );
  const y2RangeTo = (0, import_react.useMemo)(() => y2Axis?.plotRange?.[0] || 0, [y2Axis?.plotRange]);
  const y2RangeFrom = (0, import_react.useMemo)(
    () => (innerHeight - (y2Axis?.plotRange?.[1] || 0)) * (yScroll ? containerRatio : 1),
    [containerRatio, innerHeight, y2Axis?.plotRange, yScroll]
  );
  const xScale = (0, import_react.useMemo)(
    () => scaleFactory("x", xAxis, [xRangeFrom, xRangeTo]),
    [scaleFactory, xAxis, xRangeFrom, xRangeTo]
  );
  const yScale = (0, import_react.useMemo)(
    () => scaleFactory("y", yAxis, [yRangeFrom, yRangeTo]),
    [scaleFactory, yAxis, yRangeFrom, yRangeTo]
  );
  const y2Scale = (0, import_react.useMemo)(
    () => scaleFactory("y2", y2Axis, [y2RangeFrom, y2RangeTo]),
    [scaleFactory, y2Axis, y2RangeFrom, y2RangeTo]
  );
  const colorScale = (0, import_react.useMemo)(
    () => (0, import_d3.scaleOrdinal)().domain(series.map((d) => d.name)).range(series.map((d) => import_colorPallet.COLOR_PALLET[d.color] ?? d.color)).unknown("red"),
    [series]
  );
  const subgroupsWithBars = (0, import_react.useMemo)(() => {
    const data = currentData.filter(
      (serie) => serie.type === "bar" && !(stackedSeries?.length && (0, import_helpers.getStackedIndex)(stackedSeries, serie.name) > -1)
    ).map((serie) => serie.name);
    if (stackedSeries?.length) {
      stackedSeries.forEach((stackedGroup, i) => {
        if (stackedGroup.length > 0) data.push(`stacked-data-${i}`);
      });
    }
    return data;
  }, [currentData, stackedSeries]);
  const getBandwidth = (0, import_react.useCallback)(() => {
    if (xScale?.type === "BAND") {
      return xScale?.getBandwidth();
    }
    if (yScale?.type === "BAND") {
      return yScale?.getBandwidth();
    }
    const bars = currentData.filter((serie) => serie.type === "bar");
    const barsLength = bars.length;
    if (!barsLength) return 0;
    const maxDataLength = Math.max(...bars.map((bar) => bar.data.length));
    if (xScale && xScale instanceof import_scales.BandScale) return 0;
    const divisor = Math.max(
      maxDataLength,
      xScale?.scale.ticks().length ?? 0,
      xScale?.getTicks(innerWidth, "").length ?? 0,
      1
    );
    const width = innerWidth / divisor;
    if (containerRatio > 1) {
      return Math.max(0.5, width * containerRatio);
    }
    const modificator = innerWidth > 400 ? 0.5 : 0.8;
    return Math.max(0.5, Math.min(20, Math.trunc(width - width * modificator)));
  }, [currentData, innerWidth, containerRatio, xScale, yScale]);
  const subGroupScale = (0, import_react.useMemo)(
    () => getBandwidth() ? (0, import_d3.scaleBand)().domain(subgroupsWithBars).range([0, getBandwidth()]).paddingInner(0.55).padding(0.2).paddingOuter(0.01) : null,
    [getBandwidth, subgroupsWithBars]
  );
  return { xScale, y2Scale, yScale, subGroupScale, colorScale, getBandwidth };
};
//# sourceMappingURL=useScales.js.map
