"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var helpers_exports = {};
__export(helpers_exports, {
  getStackedData: () => getStackedData,
  getStackedIndex: () => getStackedIndex,
  stackData: () => stackData
});
module.exports = __toCommonJS(helpers_exports);
var React = __toESM(require("react"));
var import_d3 = require("d3");
const getStackedIndex = (groups, serie) => {
  if (!groups) return -1;
  for (let i = 0; i < groups.length; i += 1) {
    for (let j = 0; j < groups[i].length; j += 1) {
      if (groups[i][j] === serie) return i;
    }
  }
  return -1;
};
const getStackedData = (stackedData, serie) => {
  for (let i = 0; i < stackedData?.length; i += 1) {
    const data = stackedData[i].find((d) => d.key === serie.name);
    if (data) return data;
  }
  return false;
};
const checkSharedScale = (series, isHorizontal) => {
  const scales = series.map((serie) => serie.scale || (isHorizontal ? "x" : "y")).filter((value, index, self) => self.indexOf(value) === index);
  if (scales.length > 1) {
    return false;
  }
  return scales[0];
};
const stackData = (groupsStacked, series, hiddenSeries, isHorizontal) => {
  const allSeriesStackedByGroups = [];
  const scalesStackedDataMap = [];
  if (!groupsStacked) return { stackedData: allSeriesStackedByGroups, scalesStackedDataMap };
  groupsStacked?.forEach((g) => {
    const seriesFilteredByStackGroup = series.filter(
      (serie) => g.includes(serie.name) && !hiddenSeries.includes(serie.name)
    );
    const sharedScale = checkSharedScale(seriesFilteredByStackGroup, isHorizontal);
    if (!sharedScale) return;
    scalesStackedDataMap.push(sharedScale);
    const keys = seriesFilteredByStackGroup.map((serie) => serie.name);
    const stackedData = [];
    seriesFilteredByStackGroup.forEach((serie) => {
      serie.data.forEach((d, i) => {
        stackedData[i] = {
          ...stackedData[i],
          [serie.name]: typeof d === "number" ? d : d?.y || 0
        };
      });
    });
    allSeriesStackedByGroups.push((0, import_d3.stack)().offset(import_d3.stackOffsetDiverging).keys(keys)(stackedData));
  });
  return { stackedData: allSeriesStackedByGroups, scalesStackedDataMap };
};
//# sourceMappingURL=index.js.map
