"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useUniqueData_exports = {};
__export(useUniqueData_exports, {
  useUniqueData: () => useUniqueData
});
module.exports = __toCommonJS(useUniqueData_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
const useUniqueData = () => {
  const {
    currentData: data,
    xScale,
    xScrollbarPosition,
    containerRatio,
    innerWidth,
    getXValue,
    getYValue,
    getXScaleValue
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const compare = (0, import_react.useCallback)((a, b) => {
    if (a.xPosition < b.xPosition) {
      return -1;
    }
    if (a.xPosition > b.xPosition) {
      return 1;
    }
    return 0;
  }, []);
  const isBandAxis = xScale?.type === "BAND";
  return (0, import_react.useMemo)(() => {
    let valueToPositionPerSeries = [];
    if (isBandAxis) {
      valueToPositionPerSeries = data.map(
        (serie) => serie.data.filter((datum) => {
          const xScaleValue = getXScaleValue(datum);
          if (xScaleValue === void 0) return false;
          return xScaleValue >= xScrollbarPosition * (containerRatio ?? 1) && xScaleValue <= xScrollbarPosition * (containerRatio ?? 1) + innerWidth;
        }).map((datum) => {
          const x = getXValue(datum);
          const y = getYValue(datum);
          const xScaleValue = getXScaleValue(datum);
          return {
            position: xScaleValue,
            name: serie.name,
            xValue: x,
            yValue: y,
            key: datum.position,
            datum,
            color: serie.color
          };
        })
      ).flat(1);
    } else {
      valueToPositionPerSeries = data.map(
        (serie) => serie.data.filter((datum) => {
          const xScaleValue = getXScaleValue(datum);
          if (xScaleValue === void 0) return false;
          return xScaleValue >= xScrollbarPosition * (containerRatio ?? 1) && xScaleValue <= xScrollbarPosition * (containerRatio ?? 1) + innerWidth;
        }).map((datum) => {
          const xScaleValue = getXScaleValue(datum);
          const x = getXValue(datum);
          return {
            position: xScaleValue,
            name: serie.name,
            xValue: x,
            yValue: typeof datum.value === "number" ? datum.value : datum.value.y,
            key: datum.position,
            datum,
            color: serie.color
          };
        })
      ).flat(1);
    }
    const positionUniqueData = {};
    valueToPositionPerSeries.forEach((set) => {
      if (!set.position) return;
      if (positionUniqueData[set.position]) {
        positionUniqueData[set.position] = [...positionUniqueData[set.position], { ...set }];
      } else {
        positionUniqueData[set.position] = [{ ...set }];
      }
    });
    const positionUniqueDataArray = Object.keys(positionUniqueData).map((key) => {
      const xPosition = parseFloat(key);
      const dataPerPosition = positionUniqueData[xPosition];
      return { xPosition, dataPerPosition, xValue: dataPerPosition[0].xValue };
    });
    if (isBandAxis) {
      return positionUniqueDataArray;
    }
    return positionUniqueDataArray.sort(compare).map((line, i, array) => {
      const prevPoint = array[i - 1]?.xPosition ?? 0;
      const postPoint = array[i + 1]?.xPosition ?? 0;
      const rectDetector = {
        left: (line.xPosition - prevPoint) / 2,
        right: Math.abs((postPoint === 0 ? 0 : postPoint - line.xPosition) / 2)
      };
      return { ...line, rectDetector };
    });
  }, [isBandAxis, compare, data, getXScaleValue, xScrollbarPosition, containerRatio, innerWidth, getXValue, getYValue]);
};
//# sourceMappingURL=useUniqueData.js.map
