"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useVirtualizedSeries_exports = {};
__export(useVirtualizedSeries_exports, {
  useVirtualizedSeries: () => useVirtualizedSeries
});
module.exports = __toCommonJS(useVirtualizedSeries_exports);
var React = __toESM(require("react"));
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
const useVirtualizedSeries = () => {
  const {
    containerRatio,
    innerWidth,
    xScrollbarPosition,
    yScale,
    getXScaleValue,
    getYScaleValue,
    innerHeight,
    currentData: data,
    props: { xScroll, yScroll }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  return (0, import_react.useMemo)(() => {
    if (xScroll) {
      return data.map((serie) => ({
        ...serie,
        data: serie.data.filter((datum) => {
          const xScaleValue = getXScaleValue(datum);
          if (xScaleValue === void 0) return false;
          return xScaleValue >= xScrollbarPosition * (containerRatio ?? 1) - innerWidth && xScaleValue <= xScrollbarPosition * (containerRatio ?? 1) + innerWidth * 2;
        })
      }));
    }
    if (yScroll) {
      return data.map((serie) => ({
        ...serie,
        data: serie.data.filter((datum) => {
          const yScaleValue = getYScaleValue(datum);
          const offset = yScale?.getBandwidth() ?? 20;
          if (yScaleValue === void 0) return false;
          return yScaleValue > xScrollbarPosition * (containerRatio ?? 1) - offset && yScaleValue < xScrollbarPosition * (containerRatio ?? 1) + innerHeight;
        })
      }));
    }
    return data;
  }, [
    containerRatio,
    data,
    getXScaleValue,
    getYScaleValue,
    innerHeight,
    innerWidth,
    xScroll,
    xScrollbarPosition,
    yScale,
    yScroll
  ]);
};
//# sourceMappingURL=useVirtualizedSeries.js.map
