"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var A11yRegion_exports = {};
__export(A11yRegion_exports, {
  A11yRegion: () => A11yRegion
});
module.exports = __toCommonJS(A11yRegion_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
const PLURAL_DEFINITION_MAP = {
  line: "data points",
  bar: "bars",
  area: "areas",
  point: "data points"
};
const A11yRegion = ({ serieName, children, ...rest }) => {
  const { currentData } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const ariaLabel = (0, import_react.useMemo)(() => {
    const serieIndex = currentData.findIndex((serie) => serie.name === serieName);
    const serieData = currentData[serieIndex];
    if (!serieData) return "";
    return `${serieName}, ${serieData.type} series ${serieIndex + 1} of ${currentData.length} with ${serieData.data.length} ${PLURAL_DEFINITION_MAP[serieData.type]}.`;
  }, [currentData, serieName]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { role: "region", "aria-label": ariaLabel, ...rest, children });
};
//# sourceMappingURL=A11yRegion.js.map
