"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var AxisBottom_exports = {};
__export(AxisBottom_exports, {
  AxisBottom: () => AxisBottom
});
module.exports = __toCommonJS(AxisBottom_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = __toESM(require("react"));
var import_ChartContext = require("../../ChartContext.js");
var import_Axis = require("./Axis.js");
var import_Tick = require("./Tick.js");
var import_GridLine = require("./GridLine.js");
var import_colorPallet = require("../../helpers/colorPallet.js");
const AxisBottom = import_react.default.memo(() => {
  const {
    props: { xAxis, xScroll },
    innerHeight,
    xScale,
    innerWidth,
    containerRatio,
    setAxisBottomRef
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const realInnerWidth = (0, import_react.useMemo)(
    () => innerWidth * (xScroll ? containerRatio : 1),
    [containerRatio, innerWidth, xScroll]
  );
  const { tickRotation } = xAxis.tick || {};
  const { showGrid, intervalType } = xAxis;
  const textProps = (0, import_react.useMemo)(() => {
    const commomProps = { fill: import_colorPallet.COLOR_PALLET[xAxis?.tick?.color] || xAxis?.tick?.color };
    if (!tickRotation) return { ...commomProps, y: 17 };
    return {
      ...commomProps,
      dx: 8 * Math.sin(Math.PI * (tickRotation / 180)),
      dy: ".71em",
      y: Math.ceil(11.5 - 2.5 * (tickRotation / 15) * (tickRotation > 0 ? 1 : -1)),
      transform: `rotate(${tickRotation})`
    };
  }, [tickRotation, xAxis?.tick?.color]);
  const style = (0, import_react.useMemo)(() => {
    if (!tickRotation) return { textAnchor: "middle" };
    return { textAnchor: tickRotation > 0 ? "start" : "end" };
  }, [tickRotation]);
  const GridRenderer = (0, import_react.useCallback)(
    (props) => {
      if (!showGrid) return null;
      const { position, tickValue, ...rest } = props;
      const gridLineCoords = {
        x1: position,
        x2: position,
        y1: 0,
        y2: innerHeight
      };
      const tickFormatted = xScale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_GridLine.GridLine, { ...gridLineCoords, ...rest });
    },
    [innerHeight, showGrid, xScale]
  );
  const TickRenderer = (0, import_react.useCallback)(
    (props) => {
      const { position, tickValue, ...rest } = props;
      const tickLineCoords = {
        y2: 5,
        stroke: import_colorPallet.COLOR_PALLET[xAxis?.tick?.color] || xAxis?.tick?.color
      };
      const tickFormatted = xScale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Tick.Tick,
        {
          ...tickLineCoords,
          tickValue: tickFormatted,
          xTranslate: position,
          yTranslate: innerHeight,
          textProps,
          textStyle: style,
          ...rest
        }
      );
    },
    [xAxis?.tick?.color, xScale, innerHeight, textProps, style]
  );
  const axisColor = (0, import_react.useMemo)(() => import_colorPallet.COLOR_PALLET[xAxis.color] || xAxis.color, [xAxis.color]);
  return (0, import_react.useMemo)(() => {
    if (xAxis.hideAxis) return null;
    const lineCoords = {
      x1: 0,
      x2: realInnerWidth,
      y1: innerHeight,
      y2: innerHeight
    };
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Axis.Axis,
      {
        lineCoords,
        scale: xScale,
        innerRef: setAxisBottomRef,
        dimension: realInnerWidth,
        TickRenderer,
        GridRenderer,
        color: axisColor,
        intervalType
      }
    );
  }, [
    GridRenderer,
    TickRenderer,
    intervalType,
    axisColor,
    innerHeight,
    realInnerWidth,
    setAxisBottomRef,
    xAxis.hideAxis,
    xScale
  ]);
});
//# sourceMappingURL=AxisBottom.js.map
