"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var AxisLeft_exports = {};
__export(AxisLeft_exports, {
  AxisLeft: () => AxisLeft
});
module.exports = __toCommonJS(AxisLeft_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = __toESM(require("react"));
var import_ChartContext = require("../../ChartContext.js");
var import_Axis = require("./Axis.js");
var import_Tick = require("./Tick.js");
var import_GridLine = require("./GridLine.js");
var import_colorPallet = require("../../helpers/colorPallet.js");
const AxisLeft = import_react.default.memo(() => {
  const {
    props: { yAxis, yScroll },
    innerHeight,
    height,
    yScale,
    innerWidth,
    containerRatio,
    setAxisLeftRef
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const { tickRotation } = yAxis.tick || {};
  const { showGrid, intervalType } = yAxis;
  const realInnerHeight = (0, import_react.useMemo)(
    () => innerHeight * (yScroll ? containerRatio : 1),
    [containerRatio, innerHeight, yScroll]
  );
  const textProps = (0, import_react.useMemo)(() => {
    const commomProps = { fill: import_colorPallet.COLOR_PALLET[yAxis?.tick?.color] || yAxis?.tick?.color };
    if (!tickRotation) return { ...commomProps, x: -10, dy: "0.32em" };
    return {
      ...commomProps,
      dy: ".30em",
      dx: "-.10em",
      x: Math.trunc(-(11.5 - 2.5 * (tickRotation / 15) * (tickRotation > 0 ? 1 : -1))),
      transform: `rotate(${tickRotation})`
    };
  }, [tickRotation, yAxis?.tick?.color]);
  const style = (0, import_react.useMemo)(
    () => ({
      textAnchor: "end"
    }),
    []
  );
  const GridRenderer = (0, import_react.useCallback)(
    (props) => {
      if (!showGrid) return null;
      const { position, tickValue, ...rest } = props;
      const gridLineCoords = {
        x1: 0,
        x2: innerWidth,
        y1: position,
        y2: position
      };
      const tickFormatted = yScale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_GridLine.GridLine, { ...gridLineCoords, ...rest });
    },
    [showGrid, innerWidth, yScale]
  );
  const TickRenderer = (0, import_react.useCallback)(
    (props) => {
      const { position, tickValue, ...rest } = props;
      const tickLineCoords = {
        x2: -5,
        stroke: import_colorPallet.COLOR_PALLET[yAxis?.tick?.color] || yAxis?.tick?.color
      };
      const tickFormatted = yScale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Tick.Tick,
        {
          ...tickLineCoords,
          xTranslate: 0,
          yTranslate: position,
          textProps,
          textStyle: style,
          tickValue: tickFormatted,
          ...rest
        }
      );
    },
    [style, textProps, yAxis?.tick?.color, yScale]
  );
  const axisColor = (0, import_react.useMemo)(() => import_colorPallet.COLOR_PALLET[yAxis.color] || yAxis.color, [yAxis.color]);
  return (0, import_react.useMemo)(() => {
    if (yAxis.hideAxis) return null;
    const lineCoords = {
      x1: 0,
      x2: 0,
      y1: 0,
      y2: realInnerHeight
    };
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Axis.Axis,
      {
        lineCoords,
        scale: yScale,
        innerRef: setAxisLeftRef,
        dimension: height,
        GridRenderer,
        TickRenderer,
        color: axisColor,
        intervalType
      }
    );
  }, [
    GridRenderer,
    intervalType,
    TickRenderer,
    axisColor,
    height,
    realInnerHeight,
    setAxisLeftRef,
    yAxis.hideAxis,
    yScale
  ]);
});
//# sourceMappingURL=AxisLeft.js.map
