"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var AxisRight_exports = {};
__export(AxisRight_exports, {
  AxisRight: () => AxisRight
});
module.exports = __toCommonJS(AxisRight_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = __toESM(require("react"));
var import_ChartContext = require("../../ChartContext.js");
var import_Axis = require("./Axis.js");
var import_Tick = require("./Tick.js");
var import_GridLine = require("./GridLine.js");
var import_colorPallet = require("../../helpers/colorPallet.js");
const AxisRight = import_react.default.memo(() => {
  const {
    props: { y2Axis },
    innerHeight,
    y2Scale,
    innerWidth,
    setAxisRightRef
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const { tickRotation } = y2Axis?.tick || {};
  const { showGrid, intervalType } = y2Axis || {};
  const textProps = (0, import_react.useMemo)(() => {
    const commomProps = { fill: import_colorPallet.COLOR_PALLET[y2Axis?.tick?.color] || y2Axis?.tick?.color };
    if (!tickRotation) return { ...commomProps, x: 10, dy: "0.32em" };
    return {
      ...commomProps,
      dx: 8 * Math.sin(Math.PI * (tickRotation / 180)),
      dy: ".71em",
      y: 11.5 - 2.5 * (tickRotation / 15) * (tickRotation > 0 ? 1 : -1),
      transform: `rotate(${tickRotation})`
    };
  }, [tickRotation, y2Axis?.tick?.color]);
  const style = (0, import_react.useMemo)(() => {
    if (!tickRotation)
      return {
        textAnchor: "start"
      };
    return { textAnchor: tickRotation > 0 ? "start" : "end" };
  }, [tickRotation]);
  const GridRenderer = (0, import_react.useCallback)(
    (props) => {
      if (!showGrid) return null;
      const { position, tickValue, ...rest } = props;
      const gridLineCoords = {
        x1: 0,
        x2: innerWidth,
        y1: position,
        y2: position
      };
      const tickFormatted = y2Scale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_GridLine.GridLine, { ...gridLineCoords, ...rest });
    },
    [innerWidth, showGrid, y2Scale]
  );
  const TickRenderer = (0, import_react.useCallback)(
    (props) => {
      const { position, tickValue, ...rest } = props;
      const tickLineCoords = {
        x2: 5,
        stroke: import_colorPallet.COLOR_PALLET[y2Axis?.tick?.color] || y2Axis?.tick?.color
      };
      const tickFormatted = y2Scale?.getTickFormatted(tickValue);
      if (tickFormatted === "") return null;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Tick.Tick,
        {
          ...tickLineCoords,
          yTranslate: position,
          xTranslate: innerWidth,
          textProps,
          textStyle: style,
          tickValue: tickFormatted,
          ...rest
        }
      );
    },
    [innerWidth, style, textProps, y2Axis?.tick?.color, y2Scale]
  );
  const axisColor = (0, import_react.useMemo)(
    () => import_colorPallet.COLOR_PALLET[y2Axis?.color] || y2Axis?.color,
    [y2Axis?.color]
  );
  return (0, import_react.useMemo)(() => {
    if (y2Axis?.hideAxis) return null;
    const lineCoords = {
      x1: innerWidth,
      x2: innerWidth,
      y1: 0,
      y2: innerHeight
    };
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Axis.Axis,
      {
        lineCoords,
        scale: y2Scale,
        innerRef: setAxisRightRef,
        dimension: innerHeight,
        GridRenderer,
        TickRenderer,
        color: axisColor,
        intervalType
      }
    );
  }, [
    GridRenderer,
    intervalType,
    TickRenderer,
    axisColor,
    innerHeight,
    innerWidth,
    setAxisRightRef,
    y2Axis?.hideAxis,
    y2Scale
  ]);
});
//# sourceMappingURL=AxisRight.js.map
