"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ChartContainer_exports = {};
__export(ChartContainer_exports, {
  ChartContainer: () => ChartContainer
});
module.exports = __toCommonJS(ChartContainer_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
var import_useKeyboardNavigation = require("../config/useKeyboardNavigation.js");
var import_styles = require("../styles.js");
var import_AxisBottom = require("./Axis/AxisBottom.js");
var import_AxisLeft = require("./Axis/AxisLeft.js");
var import_AxisRight = require("./Axis/AxisRight.js");
var import_ClipPaths = require("./ClipPaths.js");
var import_Labels = require("./Labels/index.js");
var import_Legend = require("./Legend/Legend.js");
var import_Scrapper = require("./Scrapper/Scrapper.js");
var import_VerticalScrapper = require("./Scrapper/VerticalScrapper.js");
var import_BlurMask = require("./Scroller/BlurMask.js");
var import_Controllers = require("./Scroller/Controllers.js");
var import_ScrollableContainerX = require("./Scroller/ScrollableContainerX.js");
var import_ScrollableContainerY = require("./Scroller/ScrollableContainerY.js");
var import_SeriesFactory = require("./SeriesFactory.js");
const ChartContainer = () => {
  const {
    props: { y2Axis, yScroll, xScroll, scrapper, width: userWidth },
    activePoint,
    internalMargin,
    setScrapperPosY,
    setScrapperPosX,
    setContainerRef,
    isGrabbed,
    setIsGrabbed,
    startPosition,
    innerWidth,
    innerHeight,
    setActivePoint,
    setXScrollbarPosition,
    xScrollbarPosition,
    containerRatio,
    lastScrollbarPosition,
    setIsScrollbarVisible,
    currentData,
    width,
    height
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const { onInputKeyDown, handleOnKeyUp, handleOnBlur, handleOnFocus } = (0, import_useKeyboardNavigation.useKeyboardNavigation)();
  const onMouseEnterHandler = (0, import_react.useCallback)(() => {
    setIsScrollbarVisible(true);
    setActivePoint(null);
  }, [setActivePoint, setIsScrollbarVisible]);
  const onMouseLeaveHandler = (0, import_react.useCallback)(() => {
    setScrapperPosY(-1);
    setScrapperPosX(-1);
    setIsScrollbarVisible(false);
    setIsGrabbed(false);
  }, [setIsGrabbed, setIsScrollbarVisible, setScrapperPosX, setScrapperPosY]);
  const handleMouseMove = (0, import_react.useCallback)(
    (e) => {
      if (!isGrabbed) return;
      e.preventDefault();
      const { clientX } = e;
      const { clientY } = e;
      setActivePoint(null);
      if (xScroll) {
        const newPosition = lastScrollbarPosition.current + clientX - startPosition;
        if (newPosition < 0) setXScrollbarPosition(0);
        else if (newPosition > innerWidth - innerWidth / containerRatio)
          setXScrollbarPosition(innerWidth - innerWidth / containerRatio);
        else setXScrollbarPosition(newPosition);
      }
      if (yScroll) {
        const newPosition = lastScrollbarPosition.current + clientY - startPosition;
        if (newPosition < 0) setXScrollbarPosition(0);
        else if (newPosition > innerHeight - innerHeight / containerRatio)
          setXScrollbarPosition(innerHeight - innerHeight / containerRatio);
        else setXScrollbarPosition(newPosition);
      }
    },
    [
      isGrabbed,
      setActivePoint,
      xScroll,
      yScroll,
      lastScrollbarPosition,
      startPosition,
      setXScrollbarPosition,
      innerWidth,
      containerRatio,
      innerHeight
    ]
  );
  const handleMouseUp = (0, import_react.useCallback)(() => {
    lastScrollbarPosition.current = xScrollbarPosition;
    setIsGrabbed(false);
  }, [lastScrollbarPosition, setIsGrabbed, xScrollbarPosition]);
  const render = (0, import_react.useMemo)(() => {
    if (currentData.length === 0) return null;
    if (xScroll) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        y2Axis ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisRight.AxisRight, {}) : null,
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisLeft.AxisLeft, {}),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ScrollableContainerX.ScrollableContainerX, {})
      ] });
    }
    if (yScroll) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        y2Axis ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisRight.AxisRight, {}) : null,
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisBottom.AxisBottom, {}),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ScrollableContainerY.ScrollableContainerY, {})
      ] });
    }
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      y2Axis ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisRight.AxisRight, {}) : null,
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisLeft.AxisLeft, {}),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisBottom.AxisBottom, {}),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_SeriesFactory.SeriesFactory, {}),
      scrapper?.type === "horizontal" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Scrapper.Scrapper, {}) : null,
      scrapper?.type === "vertical" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_VerticalScrapper.VerticalScrapper, {}) : null
    ] });
  }, [currentData.length, scrapper?.type, xScroll, y2Axis, yScroll]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_styles.StyledSVGWrapper,
    {
      innerRef: setContainerRef,
      onKeyDown: onInputKeyDown,
      onKeyUp: handleOnKeyUp,
      tabIndex: activePoint ? -1 : 0,
      onBlur: handleOnBlur,
      onFocus: handleOnFocus,
      onMouseEnter: onMouseEnterHandler,
      onMouseLeave: onMouseLeaveHandler,
      onMouseMove: handleMouseMove,
      onMouseUp: handleMouseUp,
      onMouseDown: (e) => e.preventDefault(),
      isGrabbed,
      style: { width: userWidth, height },
      children: width !== 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("svg", { width, height, children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ClipPaths.ClipPaths, {}),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_BlurMask.BlurMask, {}),
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Controllers.Controllers, {}),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Legend.Legend, {}),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Labels.Labels, {})
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { className: "container", transform: `translate(${internalMargin.left},${internalMargin.top})`, children: render })
        ] })
      ] }) : null
    }
  );
};
//# sourceMappingURL=ChartContainer.js.map
