"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var BottomLegend_exports = {};
__export(BottomLegend_exports, {
  BottomLegend: () => BottomLegend
});
module.exports = __toCommonJS(BottomLegend_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_d3 = require("d3");
var import_ChartContext = require("../../ChartContext.js");
var import_LegendItem = require("./LegendItem.js");
const BottomLegend = () => {
  const {
    colorScale,
    bottomLegendWidth,
    bottomLegend,
    axisBottomHeight,
    axisLeftWidth,
    innerWidth,
    innerHeight,
    bottomLabelHeight,
    internalMargin,
    currentData,
    width: graphWidth,
    setBottomLegend
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const [xTransform, setXTransform] = (0, import_react.useState)(0);
  (0, import_react.useEffect)(() => {
    if (!bottomLegend) return;
    const cells = (0, import_d3.select)(bottomLegend).selectAll(".cell");
    const padding = 25;
    let offset = 0;
    let verticalOffset = 0;
    currentData.forEach((_, i) => {
      if (cells.nodes()[i - 1]) {
        const lastCell = (0, import_d3.select)(cells.nodes()[i - 1]);
        const d3sel = (0, import_d3.select)(cells.nodes()[i]);
        const { width: currentCellWidth } = d3sel.node()?.getBBox() ?? { width: 0 };
        const lastCellWidth = lastCell.node()?.getBBox()?.width || 0;
        if (offset + lastCellWidth + padding + currentCellWidth + 10 > graphWidth) {
          offset = 0;
          verticalOffset += 20;
        } else {
          offset += lastCellWidth + padding;
        }
        d3sel.attr("transform", `translate(${offset}, ${verticalOffset})`);
      }
    });
    setXTransform(innerWidth / 2 + internalMargin.left - bottomLegendWidth / 2);
  }, [bottomLegend, currentData, bottomLegendWidth, axisLeftWidth, innerWidth, internalMargin.left, graphWidth]);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "g",
      {
        ref: setBottomLegend,
        transform: `translate(${xTransform}, ${innerHeight + bottomLabelHeight + axisBottomHeight + internalMargin.top})`,
        className: "bottom-legend",
        children: colorScale.domain().map((domainValue) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_LegendItem.LegendItem, { domainValue }, domainValue))
      }
    ),
    [axisBottomHeight, bottomLabelHeight, colorScale, innerHeight, internalMargin.top, setBottomLegend, xTransform]
  );
};
//# sourceMappingURL=BottomLegend.js.map
