"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var LegendItem_exports = {};
__export(LegendItem_exports, {
  LegendItem: () => LegendItem
});
module.exports = __toCommonJS(LegendItem_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_constants = require("../../../constants.js");
var import_ChartContext = require("../../ChartContext.js");
const LegendItemCircle = (props) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("circle", { r: 6, ...props });
const LegendItemSquare = (props) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("rect", { x: -6, y: -6, width: 12, height: 12, ...props });
const LegendItemDiamond = (props) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { transform: "rotate(45)", children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("rect", { x: -6, y: -6, width: 12, height: 12, ...props }) });
const LegendItemsMap = {
  [import_constants.LINE.POINT_STYLE.CIRCLE]: LegendItemCircle,
  [import_constants.LINE.POINT_STYLE.SQUARE]: LegendItemSquare,
  [import_constants.LINE.POINT_STYLE.DIAMOND]: LegendItemDiamond
};
const LegendItem = (props) => {
  const {
    colorScale,
    setHiddenSeries,
    hiddenSeries,
    originalSeries: series,
    props: { types, legend }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const { domainValue } = props;
  const serieData = series.find((serie) => serie.name === domainValue);
  const LegendIcon = LegendItemsMap[serieData?.pointStyle ?? "circle"] ?? (serieData?.type === "line" || types === "scatter" ? LegendItemCircle : LegendItemSquare);
  const handleOnClick = (0, import_react.useCallback)(() => {
    if (legend?.preventFilterAction) return;
    setHiddenSeries((prev) => {
      if (prev.includes(domainValue)) return prev.filter((serie) => serie !== domainValue);
      if (prev.length + 1 !== series.length) return [...prev, domainValue];
      return prev;
    });
  }, [domainValue, legend?.preventFilterAction, series.length, setHiddenSeries]);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      "g",
      {
        onClick: handleOnClick,
        className: "cell",
        style: hiddenSeries.includes(domainValue) ? { opacity: 0.2, cursor: "pointer" } : { cursor: "pointer" },
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(LegendIcon, { fill: colorScale(domainValue) }),
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)("text", { x: 24, dy: ".32em", fontWeight: "600", children: domainValue })
        ]
      },
      domainValue
    ),
    [LegendIcon, colorScale, domainValue, handleOnClick, hiddenSeries]
  );
};
//# sourceMappingURL=LegendItem.js.map
