"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TopLegend_exports = {};
__export(TopLegend_exports, {
  TopLegend: () => TopLegend
});
module.exports = __toCommonJS(TopLegend_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_d3 = require("d3");
var import_ChartContext = require("../../ChartContext.js");
var import_LegendItem = require("./LegendItem.js");
const TopLegend = () => {
  const {
    colorScale,
    currentData,
    internalMargin,
    innerWidth,
    setTopLegend,
    width: graphWidth
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const ref = (0, import_react.useRef)(null);
  const [xTransform, setXTransform] = (0, import_react.useState)(innerWidth / 2 + internalMargin.left);
  (0, import_react.useEffect)(() => {
    if (ref.current) {
      const cells = (0, import_d3.select)(ref.current).selectAll(".cell");
      const padding = 30;
      let offset = 0;
      let verticalOffset = 0;
      currentData.forEach((_, i) => {
        if (cells.nodes()[i - 1]) {
          const lastCell = (0, import_d3.select)(cells.nodes()[i - 1]);
          const d3sel = (0, import_d3.select)(cells.nodes()[i]);
          const { width: currentCellWidth } = d3sel.node()?.getBBox() || { width: 0 };
          const lastCellWidth = lastCell.node()?.getBBox()?.width || 0;
          if (offset + lastCellWidth + padding + currentCellWidth + 10 > graphWidth) {
            offset = 0;
            verticalOffset += 20;
          } else {
            offset += lastCellWidth + padding;
          }
          d3sel.attr("transform", `translate(${offset}, ${verticalOffset})`);
        }
      });
      const bounds = ref.current.getBoundingClientRect();
      setXTransform(innerWidth / 2 + internalMargin.left - bounds.width / 2);
    }
  }, [currentData, graphWidth, innerWidth, internalMargin.left]);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { ref, transform: `translate(${xTransform},10)`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { ref: setTopLegend, children: colorScale.domain().map((domainValue) => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_LegendItem.LegendItem, { domainValue }, domainValue)) }) }),
    [xTransform, setTopLegend, colorScale]
  );
};
//# sourceMappingURL=TopLegend.js.map
