"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Scrapper_exports = {};
__export(Scrapper_exports, {
  Scrapper: () => Scrapper
});
module.exports = __toCommonJS(Scrapper_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../../ChartContext.js");
var import_ScrapperLine = require("./ScrapperLine.js");
const Scrapper = () => {
  const {
    yScale,
    getXValue,
    getYValue,
    getYScaleValue,
    getXScaleValue,
    getBandwidth,
    currentData: data
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const isBandAxis = yScale?.type === "BAND";
  const uniqueData = (0, import_react.useMemo)(() => {
    let valueToPositionPerSeries;
    if (isBandAxis) {
      valueToPositionPerSeries = data.map(
        (serie) => serie.data.map((datum) => {
          const x = getXValue(datum);
          const y = getYValue(datum);
          return {
            position: getYScaleValue(datum),
            name: serie.name,
            xValue: x,
            yValue: y,
            key: datum.position,
            datum,
            color: serie.color
          };
        })
      ).flat(1);
    } else {
      valueToPositionPerSeries = data.map(
        (serie) => serie.data.map((datum) => ({
          position: getXScaleValue(datum),
          name: serie.name,
          xValue: getXValue(datum),
          yValue: getYValue(datum),
          key: datum.position,
          datum,
          color: serie.color
        }))
      ).flat(1);
    }
    const positionUniqueData = {};
    valueToPositionPerSeries.forEach((set) => {
      if (!set.position) return;
      if (positionUniqueData[set.position]) {
        positionUniqueData[set.position] = [...positionUniqueData[set.position], { ...set }];
      } else {
        positionUniqueData[set.position] = [{ ...set }];
      }
    });
    return positionUniqueData;
  }, [data, getXScaleValue, getXValue, getYScaleValue, getYValue, isBandAxis]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: Object.keys(uniqueData).map((key) => {
    const yPosition = parseFloat(key) + (isBandAxis ? getBandwidth() / 2 : 0);
    const datum = uniqueData[key];
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ScrapperLine.ScrapperLine, { yPosition, datum }, key);
  }) });
};
//# sourceMappingURL=Scrapper.js.map
