"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ScrapperLine_exports = {};
__export(ScrapperLine_exports, {
  ScrapperLine: () => ScrapperLine
});
module.exports = __toCommonJS(ScrapperLine_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ds_popperjs = require("@elliemae/ds-popperjs");
var import_ds_system = require("@elliemae/ds-system");
var import_ChartContext = require("../../ChartContext.js");
var import_styles = require("../../styles.js");
const ScrapperLine = ({ yPosition, datum }) => {
  const {
    scrapperPosY,
    setScrapperPosY,
    innerWidth,
    yScale,
    setActivePoint,
    isGrabbed,
    props: { TooltipRenderer, scrapper }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const theme = (0, import_react.useContext)(import_ds_system.ThemeContext);
  const [referenceElement, setReferenceElement] = (0, import_react.useState)(null);
  const yPositionString = yPosition;
  const handleOnMouseEnter = (0, import_react.useCallback)(() => {
    if (!isGrabbed) setScrapperPosY(yPositionString);
    setActivePoint(null);
  }, [isGrabbed, setScrapperPosY, setActivePoint, yPositionString]);
  const strokeDetectorWidth = yScale?.type === "BAND" ? yScale?.getBandwidth() : "4px";
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
    scrapperPosY === yPositionString ? /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
      TooltipRenderer ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)("foreignObject", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
        import_ds_popperjs.DSPopperJS,
        {
          withoutAnimation: true,
          withoutArrow: true,
          customOffset: [0, 5],
          referenceElement,
          showPopover: true,
          zIndex: theme.zIndex.tooltip,
          startPlacementPreference: scrapper?.tooltipPreference,
          children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_styles.StyledMouseOverDetectionBox, {}),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_styles.StyledTooltipContainer, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TooltipRenderer, { data: datum }) })
          ]
        }
      ) }) : null,
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "line",
        {
          ref: setReferenceElement,
          x1: innerWidth,
          strokeWidth: "2px",
          stroke: "transparent",
          y1: yPosition,
          x2: innerWidth,
          y2: yPosition
        }
      ),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "line",
        {
          x1: 0,
          strokeWidth: "2px",
          stroke: "grey",
          strokeDasharray: "4 4",
          y1: yPosition,
          x2: innerWidth,
          y2: yPosition
        }
      )
    ] }) : null,
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "line",
      {
        onMouseEnter: handleOnMouseEnter,
        x1: 0,
        strokeWidth: strokeDetectorWidth,
        stroke: "transparent",
        y1: yPosition,
        x2: innerWidth,
        y2: yPosition
      }
    )
  ] });
};
//# sourceMappingURL=ScrapperLine.js.map
