"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var BlurMask_exports = {};
__export(BlurMask_exports, {
  BlurMask: () => BlurMask
});
module.exports = __toCommonJS(BlurMask_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../../ChartContext.js");
const BlurMask = () => {
  const {
    props: { xScroll, yScroll },
    xScrollbarPosition,
    innerWidth,
    internalMargin,
    containerRatio,
    innerHeight,
    chartId,
    height,
    width
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const gradient = (0, import_react.useMemo)(() => {
    if (xScrollbarPosition === 0) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "93%", style: { stopColor: "white", stopOpacity: 1 } }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "100%", style: { stopColor: "white", stopOpacity: 0 } })
      ] });
    }
    const isAtEndXScroll = innerWidth * containerRatio === (xScrollbarPosition + innerWidth / containerRatio) * containerRatio;
    const isAtEndYScroll = innerHeight * containerRatio === (xScrollbarPosition + innerHeight / containerRatio) * containerRatio;
    if (isAtEndXScroll || isAtEndYScroll) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "0%", style: { stopColor: "white", stopOpacity: 0 } }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "7%", style: { stopColor: "white", stopOpacity: 1 } })
      ] });
    }
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "0%", style: { stopColor: "white", stopOpacity: 0 } }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "7%", style: { stopColor: "white", stopOpacity: 1 } }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "93%", style: { stopColor: "white", stopOpacity: 1 } }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("stop", { offset: "100%", style: { stopColor: "white", stopOpacity: 0 } })
    ] });
  }, [containerRatio, innerHeight, innerWidth, xScrollbarPosition]);
  return (0, import_react.useMemo)(() => {
    if (containerRatio === 1) return null;
    if (xScroll && !yScroll) {
      const realWidth = xScrollbarPosition === 0 ? innerWidth + internalMargin.left : innerWidth;
      const realX = xScrollbarPosition === 0 ? -internalMargin.left : 0;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("defs", { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("linearGradient", { id: `filter-fade-${chartId}`, children: gradient }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("mask", { id: `mask-${chartId}`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("rect", { x: realX, width: realWidth, height, fill: `url(#filter-fade-${chartId}` }) })
      ] });
    }
    if (yScroll && !xScroll) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("defs", { children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("linearGradient", { x2: "0%", y2: "100%", id: `filter-fade-${chartId}`, children: gradient }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("mask", { id: `mask-y-${chartId}`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "rect",
          {
            x: -internalMargin.left,
            width,
            height: innerHeight,
            fill: `url(#filter-fade-${chartId}`
          }
        ) })
      ] });
    }
    return null;
  }, [
    chartId,
    containerRatio,
    gradient,
    height,
    innerHeight,
    innerWidth,
    internalMargin.left,
    width,
    xScroll,
    xScrollbarPosition,
    yScroll
  ]);
};
//# sourceMappingURL=BlurMask.js.map
