"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Controllers_exports = {};
__export(Controllers_exports, {
  Controllers: () => Controllers
});
module.exports = __toCommonJS(Controllers_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ds_system = require("@elliemae/ds-system");
var import_ChartContext = require("../../ChartContext.js");
var import_constants = require("../../../constants.js");
const StyledResetter = (0, import_ds_system.styled)("g")`
  cursor: ${({ isDisabled }) => isDisabled ? "not-allowed" : "pointer"};
  opacity: ${({ isDisabled }) => isDisabled ? "0.4" : "1"};
  &focus {
    outline: 2px solid blue;
  }
`;
const Controllers = () => {
  const {
    props: { xScroll },
    width,
    internalMargin,
    xScale,
    yScale,
    containerRef,
    containerRatio,
    setContainerRatio,
    lastScrollbarPosition,
    setToolbarRef,
    setXScrollbarPosition
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const isDisabled = (0, import_react.useMemo)(() => containerRatio === 1, [containerRatio]);
  const handleOnClick = (0, import_react.useCallback)(() => {
    setContainerRatio(1);
    setXScrollbarPosition(0);
    lastScrollbarPosition.current = 0;
  }, [lastScrollbarPosition, setContainerRatio, setXScrollbarPosition]);
  const handleOnKeyDown = (0, import_react.useCallback)(
    (e) => {
      e.stopPropagation();
      if (["Space", "Enter"].includes(e.code)) {
        setContainerRatio(1);
        setXScrollbarPosition(0);
        lastScrollbarPosition.current = 0;
        containerRef?.focus();
      }
      if (e.code === "Tab" && e.shiftKey) {
        e.preventDefault();
        containerRef?.focus();
      }
    },
    [containerRef, lastScrollbarPosition, setContainerRatio, setXScrollbarPosition]
  );
  if (xScale?.type === "BAND" || yScale?.type === "BAND") return null;
  if (!xScroll) return null;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    StyledResetter,
    {
      onClick: handleOnClick,
      onKeyDown: handleOnKeyDown,
      transform: `translate(${width - import_constants.TOOLBAR.RESET.WIDTH * 2},${internalMargin.top / 2 - import_constants.TOOLBAR.RESET.HEIGHT / 2})`,
      strokeLinecap: "round",
      isDisabled,
      innerRef: setToolbarRef,
      role: "button",
      "aria-label": "Reset zoom in chart",
      tabIndex: isDisabled ? -1 : 0,
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "path",
        {
          d: "M 2.875 7.75 A 5.625 5.625 0 1 1 4.5225 11.7275 L 8.2725 10.7275 L 6.5225 14.9775 L 4.5225 11.7275\n        M 0 0 H 17 V 17 H 0 V 0 ",
          fill: "#ffffff",
          stroke: "#000000",
          strokeLinecap: "round",
          strokeWidth: "1"
        }
      )
    }
  );
};
//# sourceMappingURL=Controllers.js.map
