"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ScrollBarY_exports = {};
__export(ScrollBarY_exports, {
  ScrollBarY: () => ScrollBarY
});
module.exports = __toCommonJS(ScrollBarY_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../../ChartContext.js");
const ScrollBarY = () => {
  const {
    setIsGrabbed,
    setStartPosition,
    xScrollbarPosition,
    activePoint,
    setXScrollbarPosition,
    innerHeight,
    isGrabbed,
    containerRatio,
    setScrapperPosX,
    setScrapperPosY,
    isScrollbarVisible,
    lastScrollbarPosition
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const barHeight = (0, import_react.useMemo)(() => Math.round(innerHeight / containerRatio), [containerRatio, innerHeight]);
  const handleMouseDown = (0, import_react.useCallback)(
    (e) => {
      setScrapperPosX(-1);
      setScrapperPosY(-1);
      setIsGrabbed(true);
      setStartPosition(e.clientY);
      e.preventDefault();
    },
    [setIsGrabbed, setScrapperPosY, setScrapperPosX, setStartPosition]
  );
  const handleMouseEnter = (0, import_react.useCallback)(() => {
    setScrapperPosX(-1);
  }, [setScrapperPosX]);
  const handleClickFullBar = (0, import_react.useCallback)(
    (e) => {
      let newPosition = 0;
      const bar = e.target;
      const bounds = bar.getBoundingClientRect();
      const top = e.clientY - bounds.top;
      if (top + barHeight / 2 > innerHeight) {
        newPosition = innerHeight - barHeight;
      } else if (top - barHeight / 2 > 0) {
        newPosition = top - barHeight / 2;
      }
      setXScrollbarPosition(newPosition);
      lastScrollbarPosition.current = newPosition;
      e.preventDefault();
    },
    [barHeight, innerHeight, lastScrollbarPosition, setXScrollbarPosition]
  );
  const isBarVisible = (0, import_react.useMemo)(
    () => (isScrollbarVisible || activePoint) && containerRatio > 1,
    [activePoint, containerRatio, isScrollbarVisible]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "g",
    {
      className: "scrollbary",
      transform: "translate(-6,0)",
      style: { visibility: isBarVisible ? "visible" : "hidden" },
      onMouseEnter: handleMouseEnter,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "rect",
          {
            style: { cursor: "pointer" },
            width: "6",
            height: innerHeight,
            fill: "#ebecf0c5",
            onClick: handleClickFullBar
          }
        ),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { transform: `translate(0,${xScrollbarPosition})`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "rect",
          {
            style: { cursor: isGrabbed ? "grabbing" : "grab" },
            width: "6",
            height: barHeight,
            fill: "grey",
            onMouseDown: handleMouseDown
          }
        ) })
      ]
    }
  );
};
//# sourceMappingURL=ScrollBarY.js.map
