"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ScrollableContainerX_exports = {};
__export(ScrollableContainerX_exports, {
  ScrollableContainerX: () => ScrollableContainerX
});
module.exports = __toCommonJS(ScrollableContainerX_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../../ChartContext.js");
var import_AxisBottom = require("../Axis/AxisBottom.js");
var import_SeriesFactory = require("../SeriesFactory.js");
var import_ScrollBarX = require("./ScrollBarX.js");
var import_Scrapper = require("../Scrapper/Scrapper.js");
var import_VerticalScrapper = require("../Scrapper/VerticalScrapper.js");
const ScrollableContainerX = () => {
  const {
    props: { scrapper },
    xScrollbarPosition,
    xScale,
    containerRatio,
    innerWidth,
    isGrabbed,
    containerRef,
    setXScrollbarPosition,
    setContainerRatio,
    lastScrollbarPosition,
    innerHeight,
    internalMargin,
    chartId,
    isZooming,
    setIsZooming,
    zoomStartingPosition,
    setZoomStartingPosition,
    movingPosition,
    setMovingPosition
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const getRealClientX = (0, import_react.useCallback)(
    (clientX) => clientX - internalMargin.left - (containerRef?.getBoundingClientRect().left || 0),
    [containerRef, internalMargin.left]
  );
  const Scrappers = (0, import_react.useMemo)(() => {
    if (scrapper && scrapper?.type === "horizontal") return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Scrapper.Scrapper, {});
    if (scrapper && scrapper?.type === "vertical") return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_VerticalScrapper.VerticalScrapper, {});
    return null;
  }, [scrapper]);
  const handleOnMouseDown = (0, import_react.useCallback)(
    ({ clientX }) => {
      if (!isGrabbed && xScale?.type !== "BAND") {
        setIsZooming(true);
        setZoomStartingPosition(getRealClientX(clientX));
        setMovingPosition(0);
      }
    },
    [getRealClientX, isGrabbed, setIsZooming, setMovingPosition, setZoomStartingPosition, xScale?.type]
  );
  const handleOnMouseMove = (0, import_react.useCallback)(
    ({ clientX }) => {
      if (isZooming) setMovingPosition(getRealClientX(clientX));
    },
    [getRealClientX, isZooming, setMovingPosition]
  );
  const handleOnMouseUp = (0, import_react.useCallback)(
    (e) => {
      if (!isZooming) return;
      setIsZooming(false);
      setMovingPosition(0);
      const endingPosition = getRealClientX(e.clientX);
      const diff = Math.abs(zoomStartingPosition - endingPosition);
      if (diff <= 0) return;
      const newRatio = innerWidth / (innerWidth * containerRatio / diff) < 40 ? innerWidth / 40 : innerWidth * containerRatio / diff;
      const newPosition = lastScrollbarPosition.current + (zoomStartingPosition > endingPosition ? endingPosition : zoomStartingPosition) / containerRatio;
      if (newPosition > innerWidth - innerWidth / newRatio) setXScrollbarPosition(innerWidth - innerWidth / newRatio);
      else setXScrollbarPosition(newPosition);
      setContainerRatio(newRatio);
      lastScrollbarPosition.current = newPosition;
      e.stopPropagation();
    },
    [
      isZooming,
      setIsZooming,
      setMovingPosition,
      getRealClientX,
      zoomStartingPosition,
      innerWidth,
      containerRatio,
      lastScrollbarPosition,
      setXScrollbarPosition,
      setContainerRatio
    ]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "g",
    {
      className: "scrollable-container-x",
      onMouseDown: handleOnMouseDown,
      onMouseMove: handleOnMouseMove,
      onMouseUp: handleOnMouseUp,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { mask: `url(#mask-${chartId})`, children: [
          /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { transform: `translate(${-xScrollbarPosition * containerRatio},0)`, children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_AxisBottom.AxisBottom, {}),
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_SeriesFactory.SeriesFactory, {}),
            Scrappers
          ] }),
          isZooming && movingPosition !== 0 ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "rect",
            {
              x: movingPosition < zoomStartingPosition ? movingPosition : zoomStartingPosition,
              width: Math.abs(movingPosition - zoomStartingPosition),
              height: innerHeight,
              fill: "orange",
              style: { opacity: 0.2 }
            }
          ) : null
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_ScrollBarX.ScrollBarX, {})
      ]
    }
  );
};
//# sourceMappingURL=ScrollableContainerX.js.map
