"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var SeriesFactory_exports = {};
__export(SeriesFactory_exports, {
  SeriesFactory: () => SeriesFactory
});
module.exports = __toCommonJS(SeriesFactory_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
var import_series = require("../series/index.js");
var import_helpers = require("../helpers/index.js");
var import_useVirtualizedSeries = require("../helpers/useVirtualizedSeries.js");
const SeriesFactory = () => {
  const {
    props: { groups, types },
    isHorizontal
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const virtualizedSeries = (0, import_useVirtualizedSeries.useVirtualizedSeries)();
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { className: "content", children: virtualizedSeries.map((serie) => {
      const serieProps = {
        key: serie.key,
        serie
      };
      if (serie.type === "bar" && groups && (0, import_helpers.getStackedIndex)(groups, serie.name) > -1 && isHorizontal) {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.HorizontalStackedBars, { ...serieProps });
      }
      if (serie.type === "bar" && groups && (0, import_helpers.getStackedIndex)(groups, serie.name) > -1) {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.StackedBar, { ...serieProps });
      }
      if (serie.type === "bar" && isHorizontal) {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.HorizontalBars, { ...serieProps });
      }
      if (serie.type === "bar") {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.Bars, { ...serieProps });
      }
      if (types === "scatter" && !serie.type || serie.type === "point") {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.Points, { ...serieProps });
      }
      if (serie.type === "line") {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.Line, { ...serieProps });
      }
      if (serie.type === "area") {
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_series.Area, { ...serieProps });
      }
      return null;
    }) }),
    [groups, isHorizontal, types, virtualizedSeries]
  );
};
//# sourceMappingURL=SeriesFactory.js.map
