"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Area_exports = {};
__export(Area_exports, {
  Area: () => Area
});
module.exports = __toCommonJS(Area_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_d3 = require("d3");
var import_styles = require("../styles.js");
var import_ChartContext = require("../ChartContext.js");
var import_helpers = require("../helpers/index.js");
var import_Points = require("./Points.js");
var import_constants = require("../../constants.js");
const Area = ({ serie }) => {
  const { xScale, getXScaleValue, getY2ScaleValue, getYScaleValue, innerHeight, colorScale, stackedData } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYScale = serie.scale === "y2" ? getY2ScaleValue : getYScaleValue;
  const curveStyle = (0, import_react.useMemo)(() => import_constants.curveStyleMap[serie.curveStyle ?? import_constants.LINE.CURVE_STYLE.LINEAR], [serie.curveStyle]);
  const areaD3 = (0, import_react.useMemo)(() => {
    const serieWithStackedValues = (0, import_helpers.getStackedData)(stackedData, serie);
    if (serieWithStackedValues) {
      return (0, import_d3.area)().x((_, i) => getXScaleValue(serie.data[i])).y0(([, y2]) => finalYScale(y2)).y1(([y1]) => finalYScale(y1)).curve(curveStyle)(serieWithStackedValues);
    }
    return (0, import_d3.area)().x((_, i) => getXScaleValue(serie.data[i])).y0(innerHeight).y1((_, i) => getYScaleValue(serie.data[i])).curve(curveStyle)(serie.data);
  }, [stackedData, serie, innerHeight, curveStyle, getXScaleValue, finalYScale, getYScaleValue]);
  const lineD3 = (0, import_react.useMemo)(() => {
    const serieWithStackedValues = (0, import_helpers.getStackedData)(stackedData, serie);
    if (serieWithStackedValues) {
      return (0, import_d3.line)().x((_, i) => getXScaleValue(serie.data[i])).y(([, y2]) => finalYScale(y2)).curve(curveStyle)(serieWithStackedValues);
    }
    return (0, import_d3.line)().x((_, i) => getXScaleValue(serie.data[i])).y((_, i) => getYScaleValue(serie.data[i])).curve(curveStyle)(serie.data);
  }, [stackedData, serie, curveStyle, getXScaleValue, finalYScale, getYScaleValue]);
  const xTranslate = (xScale?.getBandwidth() ?? 0) / 2;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { transform: `translate(${xTranslate}, 0)`, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Points.Points, { serie }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("path", { d: lineD3 ?? "", fill: "none", strokeWidth: 2, stroke: colorScale(serie.name) }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_styles.StyledArea, { d: areaD3 ?? "", fill: colorScale(serie.name) })
  ] }) });
};
//# sourceMappingURL=Area.js.map
