"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Bars_exports = {};
__export(Bars_exports, {
  Bars: () => Bars
});
module.exports = __toCommonJS(Bars_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_Rect = require("./Rect.js");
var import_ChartContext = require("../ChartContext.js");
var import_A11yRegion = require("../parts/A11yRegion.js");
const Bars = ({ serie }) => {
  const {
    innerHeight,
    xScale,
    getXScaleValue,
    getYScaleValue,
    getY2ScaleValue,
    subGroupScale,
    colorScale,
    getXValue,
    getYValue,
    chartId
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYScale = serie.scale === "y2" ? getY2ScaleValue : getYScaleValue;
  const negativeSize = innerHeight - finalYScale(0);
  const positiveSize = innerHeight - negativeSize;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_A11yRegion.A11yRegion,
    {
      serieName: serie.name,
      clipPath: `url(#rect-focus-ring-${chartId})`,
      fill: colorScale(serie.name),
      children: serie.data.map((bar) => {
        const x = getXValue(bar);
        const y = getYValue(bar);
        const xScaled = getXScaleValue(bar) ?? 0;
        const yScaled = finalYScale(bar) ?? 0;
        const width = subGroupScale?.bandwidth() ?? 0;
        const height = y > 0 ? positiveSize - yScaled : yScaled - finalYScale(0);
        const transformX = xScale?.type !== "BAND" ? xScaled - width / 2 : ((subGroupScale && subGroupScale(serie.name)) ?? 0) + xScaled;
        const transformY = y > 0 ? finalYScale(0) - height : finalYScale(0);
        return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { id: `${chartId}-${serie.name}-rects-${bar.key}`, transform: `translate(${transformX},0)`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_Rect.Rect,
          {
            name: serie.name,
            xValue: x,
            yValue: y,
            width,
            height,
            id: bar.key,
            y: transformY,
            isNegative: y < 0,
            datum: bar
          }
        ) }, bar.key);
      })
    }
  );
};
//# sourceMappingURL=Bars.js.map
