"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var HorizontalBars_exports = {};
__export(HorizontalBars_exports, {
  HorizontalBars: () => HorizontalBars
});
module.exports = __toCommonJS(HorizontalBars_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_Rect = require("./Rect.js");
var import_ChartContext = require("../ChartContext.js");
const HorizontalBars = ({ serie }) => {
  const {
    innerWidth,
    subGroupScale,
    getYScaleValue,
    getY2ScaleValue,
    getXScaleValue,
    colorScale,
    getXValue,
    getYValue,
    chartId
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYScale = serie.scale === "y2" ? getY2ScaleValue : getYScaleValue;
  const negativeSize = innerWidth - getXScaleValue(0);
  const positiveSize = innerWidth - negativeSize;
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { fill: colorScale(serie.name), clipPath: `url(#rect-focus-ring-${chartId})`, children: serie.data.map((bar) => {
      const x = getXValue(bar);
      const y = getYValue(bar);
      const xScaled = getXScaleValue(bar) ?? 0;
      const width = x < 0 ? positiveSize - xScaled : xScaled - getXScaleValue(0);
      const height = subGroupScale?.bandwidth() ?? 0;
      const transformX = x < 0 ? getXScaleValue(0) - width : getXScaleValue(0);
      const transformY = ((subGroupScale && subGroupScale(serie.name)) ?? 0) + finalYScale(y);
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { transform: `translate(${transformX},${transformY})`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Rect.Rect,
        {
          datum: bar,
          name: serie.name,
          width,
          height,
          id: bar.key,
          x: 0,
          xValue: x,
          yValue: y
        }
      ) }, bar.key);
    }) }),
    [
      chartId,
      colorScale,
      finalYScale,
      getXScaleValue,
      getXValue,
      getYValue,
      positiveSize,
      serie.data,
      serie.name,
      subGroupScale
    ]
  );
};
//# sourceMappingURL=HorizontalBars.js.map
