"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var HorizontalStackedBars_exports = {};
__export(HorizontalStackedBars_exports, {
  HorizontalStackedBars: () => HorizontalStackedBars
});
module.exports = __toCommonJS(HorizontalStackedBars_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_Rect = require("./Rect.js");
var import_ChartContext = require("../ChartContext.js");
var import_helpers = require("../helpers/index.js");
const HorizontalStackedBars = ({ serie }) => {
  const {
    props: { groups },
    yScale,
    stackedData,
    subGroupScale,
    colorScale,
    chartId,
    getXScaleValue,
    getYValue
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const serieWithStackedValues = (0, import_helpers.getStackedData)(stackedData, serie);
  const stackIndex = (0, import_helpers.getStackedIndex)(groups, serie.name);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: serie.data.map((bar, i) => {
      const sequence = serieWithStackedValues ? serieWithStackedValues[bar.position] : [0, 0];
      const sequence0 = getXScaleValue(sequence[0]);
      const sequence1 = getXScaleValue(sequence[1]);
      const isFloorStack = sequence[0] === 0;
      const xValue = sequence[1] - sequence[0];
      const yValue = getYValue(serie.data[i]);
      const width = sequence1 - sequence0 - (!isFloorStack ? 2 : 0);
      const height = subGroupScale?.bandwidth() ?? 0;
      const transformX = sequence0 + (!isFloorStack ? 2 : 0);
      const transformY = (subGroupScale ? subGroupScale(`stacked-data-${stackIndex}`) ?? 0 : 0) + (yScale?.get(yValue) ?? 0);
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { clipPath: `url(#rect-focus-ring-${chartId})`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { fill: colorScale(serie.name), transform: `translate(0, ${transformY})`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Rect.Rect,
        {
          width,
          height,
          x: transformX,
          xValue,
          yValue,
          id: serie.data[i]?.key,
          name: serie.name,
          datum: serie.data[i]
        }
      ) }) }, serie.data[i]?.key);
    }) }),
    [
      chartId,
      colorScale,
      getXScaleValue,
      getYValue,
      serie.data,
      serie.name,
      serieWithStackedValues,
      stackIndex,
      subGroupScale,
      yScale
    ]
  );
};
//# sourceMappingURL=HorizontalStackedBars.js.map
