"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Line_exports = {};
__export(Line_exports, {
  Line: () => Line
});
module.exports = __toCommonJS(Line_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_d3 = require("d3");
var import_Points = require("./Points.js");
var import_ChartContext = require("../ChartContext.js");
var import_constants = require("../../constants.js");
var import_DataTestIds = require("../DataTestIds.js");
var import_A11yRegion = require("../parts/A11yRegion.js");
const Line = ({ serie }) => {
  const { xScale, colorScale, getYScaleValue, getY2ScaleValue, getXScaleValue, getXValue, getYValue } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const ref = (0, import_react.useRef)(null);
  const curveStyle = (0, import_react.useMemo)(() => import_constants.curveStyleMap[serie.curveStyle ?? import_constants.LINE.CURVE_STYLE.LINEAR], [serie.curveStyle]);
  const currentYScale = (0, import_react.useMemo)(
    () => serie.scale === "y2" ? getY2ScaleValue : getYScaleValue,
    [getY2ScaleValue, getYScaleValue, serie.scale]
  );
  const lineD3 = (0, import_react.useMemo)(
    () => (0, import_d3.line)().x((_, i) => getXScaleValue(serie.data[i])).y((_, i) => currentYScale(serie.data[i])).curve(curveStyle),
    [curveStyle, getXScaleValue, currentYScale, serie.data]
  );
  (0, import_react.useEffect)(() => {
    if (!ref.current) return;
    const groupContent = (0, import_d3.select)(ref?.current);
    groupContent.selectAll("*").remove();
    const path = groupContent.append("path").datum(serie.data).attr("fill", "none").attr("stroke", colorScale(serie.name)).attr("stroke-linejoin", "round").attr("stroke-width", 2).attr("d", lineD3);
    if (serie.dashStyle)
      path.attr("stroke-dasharray", import_constants.LINE.DASH_STYLE_VALUES[serie.dashStyle]);
  }, [colorScale, getXValue, getYValue, lineD3, serie, xScale]);
  const xTranslate = (0, import_react.useMemo)(() => (xScale?.getBandwidth?.() ?? 0) / 2, [xScale]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_A11yRegion.A11yRegion, { serieName: serie.name, transform: `translate(${xTranslate}, 0)`, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { ref, "data-testid": import_DataTestIds.DataVizDataTestIds.LINE }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_Points.Points, { serie })
  ] });
};
//# sourceMappingURL=Line.js.map
