"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Point_exports = {};
__export(Point_exports, {
  Point: () => Point
});
module.exports = __toCommonJS(Point_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
var import_constants = require("../../constants.js");
var import_FocusableRegion = require("../parts/FocusableRegion.js");
var import_TrendHighlight = require("../parts/TrendHighlight.js");
var import_DataTestIds = require("../DataTestIds.js");
const Point = ({
  x,
  y,
  xValue,
  yValue,
  name,
  pointStyle,
  pointRadius,
  id,
  opacity,
  datum
}) => {
  const {
    activePoint,
    scrapperPosY,
    scrapperPosX,
    getYValueFormatted,
    getXValueFormatted,
    setActivePoint,
    props: { scrapper, TooltipRenderer, withTrendHighlight, y2Axis, yAxis, xAxis }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYAxis = datum.scale === "y2" ? y2Axis : yAxis;
  const yValueFormatted = getYValueFormatted(datum);
  const xValueFormatted = getXValueFormatted(datum);
  const isFocused = (0, import_react.useMemo)(() => {
    if (activePoint?.key === id) {
      return true;
    }
    if (scrapper?.type === import_constants.SCRAPPER.TYPE_HORIZONTAL) {
      return y === scrapperPosY;
    }
    if (scrapper?.type === import_constants.SCRAPPER.TYPE_VERTICAL) {
      return x === scrapperPosX;
    }
    return false;
  }, [activePoint, id, scrapper, y, scrapperPosY, x, scrapperPosX]);
  const point = (0, import_react.useMemo)(() => {
    const commonProps = {
      tabIndex: -1,
      ref: (_ref) => {
        if (isFocused) {
          _ref?.focus();
        }
      },
      "aria-label": `${datum.serie} ${xAxis.label || ""} ${xValueFormatted} ${finalYAxis?.label || ""} ${yValueFormatted}`,
      role: "img"
    };
    if (import_constants.LINE.POINT_STYLE.DIAMOND === pointStyle) {
      const squareEdge = pointRadius * 2;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { transform: "rotate(45)", children: [
        isFocused ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "rect",
          {
            x: -pointRadius - import_constants.FOCUS_RING.STROKE_WIDTH,
            y: -pointRadius - import_constants.FOCUS_RING.STROKE_WIDTH,
            width: squareEdge + import_constants.FOCUS_RING.STROKE_WIDTH * 2,
            height: squareEdge + import_constants.FOCUS_RING.STROKE_WIDTH * 2,
            fill: "none",
            stroke: import_constants.FOCUS_RING.COLOR,
            strokeWidth: import_constants.FOCUS_RING.STROKE_WIDTH
          }
        ) : null,
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("rect", { ...commonProps, x: -pointRadius, y: -pointRadius, width: squareEdge, height: squareEdge })
      ] });
    }
    if (import_constants.LINE.POINT_STYLE.SQUARE === pointStyle) {
      const squareEdge = pointRadius * 2;
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
        isFocused ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "rect",
          {
            x: -pointRadius - import_constants.FOCUS_RING.STROKE_WIDTH,
            y: -pointRadius - import_constants.FOCUS_RING.STROKE_WIDTH,
            width: squareEdge + import_constants.FOCUS_RING.STROKE_WIDTH * 2,
            height: squareEdge + import_constants.FOCUS_RING.STROKE_WIDTH * 2,
            fill: "none",
            stroke: import_constants.FOCUS_RING.COLOR,
            strokeWidth: import_constants.FOCUS_RING.STROKE_WIDTH
          }
        ) : null,
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)("rect", { ...commonProps, x: -pointRadius, y: -pointRadius, width: squareEdge, height: squareEdge })
      ] });
    }
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("g", { children: [
      isFocused ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "circle",
        {
          r: (pointRadius ?? import_constants.LINE.DEFAULT_POINT_RADIUS) + import_constants.FOCUS_RING.STROKE_WIDTH,
          fill: "none",
          stroke: import_constants.FOCUS_RING.COLOR,
          strokeWidth: import_constants.FOCUS_RING.STROKE_WIDTH
        }
      ) }) : null,
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "circle",
        {
          ...commonProps,
          r: pointRadius ?? (isFocused ? import_constants.LINE.DEFAULT_POINT_RADIUS : 0),
          opacity
        }
      )
    ] });
  }, [
    datum.serie,
    finalYAxis?.label,
    isFocused,
    opacity,
    pointRadius,
    pointStyle,
    xAxis.label,
    xValueFormatted,
    yValueFormatted
  ]);
  const handleMouseEnter = (0, import_react.useCallback)(() => {
    if (!scrapper) setActivePoint(datum);
  }, [datum, scrapper, setActivePoint]);
  const handleOnMouseLeave = (0, import_react.useCallback)(() => {
    if (!scrapper) setActivePoint(null);
  }, [scrapper, setActivePoint]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      "g",
      {
        "data-testid": import_DataTestIds.DataVizDataTestIds.POINT,
        onMouseEnter: handleMouseEnter,
        onMouseLeave: handleOnMouseLeave,
        transform: `translate(${x},${y})`,
        children: [
          point,
          activePoint?.key === id && TooltipRenderer ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_FocusableRegion.FocusableRegion,
            {
              id,
              width: (pointRadius ?? 3) * 4,
              height: (pointRadius ?? 3) * 4,
              style: { transform: `translate(-${pointRadius ?? 3}px, -${pointRadius ?? 3}px)` },
              content: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TooltipRenderer, { data: [{ name, yValue, xValue, datum }] })
            }
          ) : null
        ]
      }
    ),
    isFocused && withTrendHighlight ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_TrendHighlight.TrendHighlight, { currentDatum: datum }) : null
  ] });
};
//# sourceMappingURL=Point.js.map
