"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Points_exports = {};
__export(Points_exports, {
  Points: () => Points
});
module.exports = __toCommonJS(Points_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_Point = require("./Point.js");
var import_ChartContext = require("../ChartContext.js");
var import_helpers = require("../helpers/index.js");
const Points = ({ serie }) => {
  const {
    colorScale,
    getXValue,
    getYValue,
    getY2ScaleValue,
    getYScaleValue,
    getXScaleValue,
    stackedData,
    props: { types }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYScale = serie.scale === "y2" ? getY2ScaleValue : getYScaleValue;
  const opacity = (0, import_react.useMemo)(() => types === "scatter" ? 0.8 : 1, [types]);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { fill: colorScale(serie.name), children: serie.data.map((point, i) => {
      const { pointRadius = 0, pointStyle = "" } = serie;
      const serieWithStackedValues = (0, import_helpers.getStackedData)(stackedData, serie);
      const deltaY = serieWithStackedValues ? serieWithStackedValues[i][0] : 0;
      const x = getXValue(point);
      const y = getYValue(point);
      const xPosition = getXScaleValue(point) ?? 0;
      const yPosition = finalYScale(y + deltaY);
      return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        import_Point.Point,
        {
          pointRadius,
          id: point.key,
          opacity,
          x: xPosition,
          y: yPosition,
          xValue: x,
          yValue: y,
          pointStyle,
          name: serie.name,
          datum: point,
          color: colorScale(serie.name)
        },
        `${point.key}-p`
      );
    }) }),
    [colorScale, finalYScale, getXScaleValue, getXValue, getYValue, opacity, serie, stackedData]
  );
};
//# sourceMappingURL=Points.js.map
