"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Rect_exports = {};
__export(Rect_exports, {
  Rect: () => Rect
});
module.exports = __toCommonJS(Rect_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ChartContext = require("../ChartContext.js");
var import_constants = require("../../constants.js");
var import_FocusableRegion = require("../parts/FocusableRegion.js");
var import_DataTestIds = require("../DataTestIds.js");
const Rect = ({
  name,
  width,
  height,
  isNegative = false,
  x = 0,
  y = 0,
  id,
  xValue,
  yValue,
  datum
}) => {
  const {
    activePoint,
    chartId,
    isHorizontal,
    setActivePoint,
    getYValueFormatted,
    getXValueFormatted,
    props: { TooltipRenderer, scrapper, xAxis, yAxis, y2Axis }
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const finalYAxis = datum.scale === "y2" ? y2Axis : yAxis;
  const yValueFormatted = getYValueFormatted(datum);
  const xValueFormatted = getXValueFormatted(datum);
  const isFocused = activePoint?.key === id;
  const clipPathSign = (0, import_react.useMemo)(() => {
    if (isHorizontal) return "";
    if (isNegative) return `url(#rects-negative-${chartId})`;
    return `url(#rects-positive-${chartId})`;
  }, [chartId, isHorizontal, isNegative]);
  const transform = (0, import_react.useMemo)(() => {
    if (isHorizontal) return ``;
    return `scale(1,-1) translate(0,${-height})`;
  }, [height, isHorizontal]);
  const handleMouseEnter = (0, import_react.useCallback)(() => {
    if (!scrapper) setActivePoint(datum);
  }, [datum, scrapper, setActivePoint]);
  const handleOnMouseLeave = (0, import_react.useCallback)(() => {
    if (!scrapper) setActivePoint(null);
  }, [scrapper, setActivePoint]);
  return (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { clipPath: clipPathSign, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
      "g",
      {
        id: isFocused ? `data-focused-${chartId}` : "",
        transform,
        onMouseEnter: handleMouseEnter,
        onMouseLeave: handleOnMouseLeave,
        "data-testid": import_DataTestIds.DataVizDataTestIds.BAR,
        children: [
          isFocused ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "rect",
            {
              x: (isHorizontal ? x : 0) - import_constants.FOCUS_RING.STROKE_WIDTH,
              y: (!isHorizontal ? -y : 0) - import_constants.FOCUS_RING.STROKE_WIDTH,
              width: width + import_constants.FOCUS_RING.OFFSET,
              height: height + import_constants.FOCUS_RING.OFFSET,
              fill: "none",
              rx: "1",
              ry: "1",
              stroke: import_constants.FOCUS_RING.COLOR,
              strokeWidth: import_constants.FOCUS_RING.STROKE_WIDTH
            }
          ) : null,
          /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "rect",
            {
              width,
              height,
              y: -y,
              x,
              "aria-label": `${datum.serie} ${xAxis.label || ""} ${xValueFormatted} ${finalYAxis?.label || ""} ${yValueFormatted}`,
              role: "img",
              tabIndex: -1,
              ref: (_ref) => {
                if (isFocused) {
                  _ref?.focus();
                }
              }
            }
          ),
          activePoint?.key === id && TooltipRenderer ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            import_FocusableRegion.FocusableRegion,
            {
              id,
              y,
              x,
              width,
              height,
              transform,
              content: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TooltipRenderer, { data: [{ name, yValue, xValue, datum }] })
            }
          ) : ""
        ]
      }
    ) }),
    [
      clipPathSign,
      isFocused,
      chartId,
      transform,
      handleMouseEnter,
      handleOnMouseLeave,
      isHorizontal,
      x,
      y,
      width,
      height,
      datum,
      xAxis.label,
      xValueFormatted,
      finalYAxis?.label,
      yValueFormatted,
      activePoint?.key,
      id,
      TooltipRenderer,
      name,
      yValue,
      xValue
    ]
  );
};
//# sourceMappingURL=Rect.js.map
