"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var StackedBar_exports = {};
__export(StackedBar_exports, {
  StackedBar: () => StackedBar
});
module.exports = __toCommonJS(StackedBar_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_Rect = require("./Rect.js");
var import_ChartContext = require("../ChartContext.js");
var import_helpers = require("../helpers/index.js");
const StackedBar = ({ serie }) => {
  const {
    props: { groups },
    xScale,
    yScale,
    stackedData,
    subGroupScale,
    colorScale,
    chartId,
    getXValue,
    getXScaleValue
  } = (0, import_react.useContext)(import_ChartContext.ChartContext);
  const serieWithStackedValues = (0, import_helpers.getStackedData)(stackedData, serie);
  const stackIndex = (0, import_helpers.getStackedIndex)(groups, serie.name);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { clipPath: `url(#rect-focus-ring-${chartId})`, children: serie.data.map((bar, i) => {
    const sequence = serieWithStackedValues ? serieWithStackedValues[bar.position] : [0, 0];
    const isFloorStack = sequence[0] === 0;
    const xValue = getXValue(bar);
    const xScaleValue = getXScaleValue(bar) ?? 0;
    const yValue = sequence[1] - sequence[0];
    const width = subGroupScale?.bandwidth() ?? 0;
    const height = (yScale?.get(sequence[0]) ?? 0) - (yScale?.get(sequence[1]) ?? 0) - (!isFloorStack ? 1 : 0);
    const transformY = (yScale?.get(sequence[1]) ?? 0) + (sequence[0] < 0 ? 2 : 0);
    const transformX = xScale?.type !== "BAND" ? xScaleValue - width / 2 : xScaleValue + (subGroupScale ? subGroupScale(`stacked-data-${stackIndex}`) ?? 0 : 0);
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)("g", { fill: colorScale(serie.name), transform: `translate(${transformX},0)`, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_Rect.Rect,
      {
        width,
        height,
        xValue,
        yValue,
        y: transformY,
        id: serie.data[i].key,
        name: serie.name,
        datum: bar
      }
    ) }, serie.data[i].key);
  }) });
};
//# sourceMappingURL=StackedBar.js.map
