"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var styles_exports = {};
__export(styles_exports, {
  StyleFocusableRegion: () => StyleFocusableRegion,
  StyledArea: () => StyledArea,
  StyledAxis: () => StyledAxis,
  StyledAxisLabel: () => StyledAxisLabel,
  StyledGrid: () => StyledGrid,
  StyledLine: () => StyledLine,
  StyledMouseOverDetectionBox: () => StyledMouseOverDetectionBox,
  StyledSVGWrapper: () => StyledSVGWrapper,
  StyledTooltipContainer: () => StyledTooltipContainer
});
module.exports = __toCommonJS(styles_exports);
var React = __toESM(require("react"));
var import_ds_system = require("@elliemae/ds-system");
const StyledSVGWrapper = import_ds_system.styled.div`
  rect:focus,
  rect:focus-visible,
  circle:focus,
  circle:focus-visible {
    outline: none;
  }

  :focus,
  :focus-visible {
    outline: none;
  }

  cursor: ${({ isGrabbed }) => isGrabbed ? "grabbing" : "default"};

  text {
    font-size: 1rem;
  }

  min-width: 300px;
`;
const StyledAxis = (0, import_ds_system.styled)("line")`
  stroke-width: 2px;
  stroke: ${({ theme }) => theme.colors.neutral["700"]};
  ${({ axisColor }) => axisColor ? `stroke: ${axisColor}` : ""}
`;
const StyledAxisLabel = (0, import_ds_system.styled)("text")`
  font-size: 1rem;
  font-weight: 600;
`;
const StyledGrid = (0, import_ds_system.styled)("g")`
  line {
    opacity: 0.2;
  }
`;
const StyleFocusableRegion = import_ds_system.styled.div`
  width: ${({ size = 1 }) => size * 2}px;
  height: ${({ size = 1 }) => size * 2}px;
  outline: none;
  &:focus {
    outline: none;
  }
`;
const StyledLine = (0, import_ds_system.styled)("path")`
  fill: none;
  stroke-width: 3;
  stroke-linejoin: round;
`;
const StyledArea = (0, import_ds_system.styled)("path")`
  stroke-width: 3;
  stroke-linejoin: round;
  opacity: 0.2;
`;
const StyledTooltipContainer = import_ds_system.styled.div`
  max-width: 350px;
  background-color: white;
`;
const StyledMouseOverDetectionBox = import_ds_system.styled.div`
  position: absolute;
  top: -15px;
  right: -15px;
  width: calc(100% + 30px);
  height: calc(100% + 30px);
  z-index: -1;
`;
//# sourceMappingURL=styles.js.map
