"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var constants_exports = {};
__export(constants_exports, {
  FOCUS_RING: () => FOCUS_RING,
  LINE: () => LINE,
  SCALE_TYPES: () => SCALE_TYPES,
  SCRAPPER: () => SCRAPPER,
  SERIE_TYPES: () => SERIE_TYPES,
  TIME_OFFSET: () => TIME_OFFSET,
  TOOLBAR: () => TOOLBAR,
  curveStyleMap: () => curveStyleMap
});
module.exports = __toCommonJS(constants_exports);
var React = __toESM(require("react"));
var import_d3 = require("d3");
const SCALE_TYPES = {
  LINEAR: "linear",
  BAND: "band",
  LOG: "log",
  TIME: "time"
};
const FOCUS_RING = {
  COLOR: "#335cad",
  STROKE_WIDTH: 2,
  OFFSET: 4
};
const SERIE_TYPES = { LINE: "line", BAR: "bar", AREA: "area", POINT: "point" };
const SCRAPPER = {
  TYPE_HORIZONTAL: "horizontal",
  TYPE_VERTICAL: "vertical"
};
const LINE = {
  POINT_STYLE: {
    CIRCLE: "CIRCLE",
    SQUARE: "SQUARE",
    DIAMOND: "DIAMOND"
  },
  DEFAULT_POINT_RADIUS: 4,
  DASH_STYLE: {
    SHORTDOT: "SHORTDOT",
    SHORTDASHDOT: "SHORTDASHDOT",
    DASH: "DASH",
    SHORTDASH: "SHORTDASH"
  },
  DASH_STYLE_VALUES: {
    SHORTDOT: [2, 2],
    SHORTDASHDOT: [6, 2, 2, 2],
    DASH: [8, 6],
    SHORTDASH: [6, 2]
  },
  CURVE_STYLE: {
    LINEAR: "LINEAR",
    SPLINE: "SPLINE"
  }
};
const curveStyleMap = {
  [LINE.CURVE_STYLE.LINEAR]: import_d3.curveLinear,
  [LINE.CURVE_STYLE.SPLINE]: import_d3.curveMonotoneX
};
const TOOLBAR = {
  RESET: {
    HEIGHT: 21,
    WIDTH: 21
  }
};
const TIME_OFFSET = {
  HOUR: import_d3.timeHour,
  MINUTE: import_d3.timeMinute,
  WEEK: import_d3.timeWeek,
  DAY: import_d3.timeDay,
  MONTH: import_d3.timeMonth
};
//# sourceMappingURL=constants.js.map
