import * as React from "react";
import { PropTypes, globalAttributesPropTypes, xstyledPropTypes } from "@elliemae/ds-props-helpers";
const defaultProps = {
  gutter: "xxxs"
};
const DSSingleStackedBarPropTypes = {
  ...globalAttributesPropTypes,
  ...xstyledPropTypes,
  height: PropTypes.string.description("Height of the bar").isRequired,
  gutter: PropTypes.string.description("Gap between the bars").defaultValue("xxxs"),
  TooltipRenderer: PropTypes.func.description("Callback function that returns a custom renderer for the tooltip"),
  LegendRenderer: PropTypes.func.description("Callback function that returns a custom renderer for the legend"),
  data: PropTypes.arrayOf(
    PropTypes.shape({ name: PropTypes.string, data: PropTypes.number, color: PropTypes.string })
  ).description("Array of the series which represent the chart")
};
export {
  DSSingleStackedBarPropTypes,
  defaultProps
};
//# sourceMappingURL=react-desc-prop-types.js.map
