import * as React from "react";
import { styled, css } from "@elliemae/ds-system";
import { Grid } from "@elliemae/ds-grid";
import { DSSingleStackedBarSlots, DSSingleStackedBarName } from "./exported-related/index.js";
const focusRing = css`
  outline: 2px solid brand-700;
  outline-offset: 2px;
`;
const StyledBar = styled(Grid)`
  &:focus,
  :focus-visible {
    ${focusRing}
  }
`;
const Wrapper = styled(Grid, { name: DSSingleStackedBarName, slot: DSSingleStackedBarSlots.WRAPPER })``;
const StyledTooltipContainer = styled.div`
  max-width: 350px;
  background-color: white;
`;
const StyledMouseOverDetectionBox = styled.div`
  position: absolute;
  top: -15px;
  right: -15px;
  width: calc(100% + 30px);
  height: calc(100% + 30px);
  z-index: -1;
`;
export {
  StyledBar,
  StyledMouseOverDetectionBox,
  StyledTooltipContainer,
  Wrapper
};
//# sourceMappingURL=styles.js.map
