import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useMemo, useContext } from "react";
import { ChartContext } from "../ChartContext.js";
const PLURAL_DEFINITION_MAP = {
  line: "data points",
  bar: "bars",
  area: "areas",
  point: "data points"
};
const A11yRegion = ({ serieName, children, ...rest }) => {
  const { currentData } = useContext(ChartContext);
  const ariaLabel = useMemo(() => {
    const serieIndex = currentData.findIndex((serie) => serie.name === serieName);
    const serieData = currentData[serieIndex];
    if (!serieData) return "";
    return `${serieName}, ${serieData.type} series ${serieIndex + 1} of ${currentData.length} with ${serieData.data.length} ${PLURAL_DEFINITION_MAP[serieData.type]}.`;
  }, [currentData, serieName]);
  return /* @__PURE__ */ jsx("g", { role: "region", "aria-label": ariaLabel, ...rest, children });
};
export {
  A11yRegion
};
//# sourceMappingURL=A11yRegion.js.map
