import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import React2 from "react";
import { StyledAxis } from "../../styles.js";
const Axis = React2.memo((props) => {
  const { dimension, intervalType, color, GridRenderer, TickRenderer, lineCoords, scale, innerRef } = props;
  const ticks = scale?.getTicks(dimension, intervalType);
  const ticksScaled = scale?.getTicksScaled(dimension, intervalType);
  if (!ticks || !ticksScaled) return null;
  const { x1, x2, y1, y2 } = lineCoords;
  return /* @__PURE__ */ jsxs("g", { className: "axis", children: [
    /* @__PURE__ */ jsxs("g", { ref: innerRef, children: [
      /* @__PURE__ */ jsx(StyledAxis, { className: "domain", x1, x2, y1, y2, axisColor: color }),
      /* @__PURE__ */ jsx("g", { className: "ticks", children: ticks.map((t, i) => /* @__PURE__ */ jsx(TickRenderer, { position: ticksScaled[i], tickValue: t }, ticksScaled[i])) })
    ] }),
    /* @__PURE__ */ jsx("g", { className: "grid", children: ticks.map((t, i) => /* @__PURE__ */ jsx(GridRenderer, { position: ticksScaled[i], tickValue: t }, ticksScaled[i])) })
  ] });
});
export {
  Axis
};
//# sourceMappingURL=Axis.js.map
