import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useContext, useMemo } from "react";
import { ChartContext } from "../ChartContext.js";
const ClipPaths = () => {
  const { innerWidth, containerRatio, innerHeight, chartId, yScale } = useContext(ChartContext);
  return useMemo(() => {
    if (yScale?.type === "BAND") {
      return /* @__PURE__ */ jsx("defs", { children: /* @__PURE__ */ jsx("clipPath", { id: `rect-focus-ring-${chartId}`, children: /* @__PURE__ */ jsx("rect", { width: innerWidth + 4, height: innerHeight * containerRatio, x: 1 }) }) });
    }
    return /* @__PURE__ */ jsx("defs", { children: /* @__PURE__ */ jsx("clipPath", { id: `rect-focus-ring-${chartId}`, children: /* @__PURE__ */ jsx("rect", { width: innerWidth * containerRatio + 4, height: innerHeight + 4, x: -4, y: -5 }) }) });
  }, [chartId, containerRatio, innerHeight, innerWidth, yScale?.type]);
};
export {
  ClipPaths
};
//# sourceMappingURL=ClipPaths.js.map
