import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import { useState, useContext, useMemo } from "react";
import { DSPopperJS } from "@elliemae/ds-popperjs";
import { ThemeContext } from "@elliemae/ds-system";
import { StyledTooltipContainer, StyledMouseOverDetectionBox } from "../styles.js";
const FocusableRegion = (props) => {
  const [referenceElement, setReferenceElement] = useState(null);
  const theme = useContext(ThemeContext);
  const { content, ...rest } = props;
  return useMemo(
    () => /* @__PURE__ */ jsx("foreignObject", { ...rest, ref: setReferenceElement, children: /* @__PURE__ */ jsxs(
      DSPopperJS,
      {
        withoutAnimation: true,
        referenceElement,
        showPopover: true,
        zIndex: theme.zIndex.tooltip,
        children: [
          /* @__PURE__ */ jsx(StyledMouseOverDetectionBox, {}),
          /* @__PURE__ */ jsx(StyledTooltipContainer, { children: content })
        ]
      }
    ) }),
    [content, referenceElement, rest, theme.zIndex.tooltip]
  );
};
export {
  FocusableRegion
};
//# sourceMappingURL=FocusableRegion.js.map
