import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import { useContext, useMemo } from "react";
import { ChartContext } from "../../ChartContext.js";
import { Label } from "./Label.js";
const Labels = () => {
  const {
    setBottomLabel,
    setLeftLabel,
    setRightLabel,
    internalMargin,
    innerHeight,
    innerWidth,
    leftLegendWidth,
    leftLabelWidth,
    axisBottomHeight,
    axisRightWidth,
    props: { xAxis, y2Axis, yAxis }
  } = useContext(ChartContext);
  const { label: xLabel } = xAxis || {};
  const { label: yLabel } = yAxis || {};
  const { label: y2Label } = y2Axis || {};
  return useMemo(
    () => /* @__PURE__ */ jsxs("g", { className: "labels", children: [
      y2Label ? /* @__PURE__ */ jsx(
        Label,
        {
          innerRef: setRightLabel,
          x: innerWidth + internalMargin.left + axisRightWidth,
          y: innerHeight / 2 + internalMargin.top,
          label: y2Label,
          rotateDegrees: 90
        }
      ) : null,
      yLabel ? /* @__PURE__ */ jsx(
        Label,
        {
          innerRef: setLeftLabel,
          x: leftLegendWidth + leftLabelWidth,
          y: innerHeight / 2 + internalMargin.top,
          label: yLabel,
          rotateDegrees: -90
        }
      ) : null,
      xLabel ? /* @__PURE__ */ jsx(
        Label,
        {
          innerRef: setBottomLabel,
          x: innerWidth / 2 + internalMargin.left,
          y: innerHeight + axisBottomHeight + internalMargin.top,
          label: xLabel
        }
      ) : null
    ] }),
    [
      axisBottomHeight,
      axisRightWidth,
      innerHeight,
      innerWidth,
      internalMargin.left,
      internalMargin.top,
      leftLabelWidth,
      leftLegendWidth,
      setBottomLabel,
      setLeftLabel,
      setRightLabel,
      xLabel,
      y2Label,
      yLabel
    ]
  );
};
export {
  Labels
};
//# sourceMappingURL=index.js.map
