import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useContext, useState, useEffect } from "react";
import { ChartContext } from "../../ChartContext.js";
import { LegendItem } from "./LegendItem.js";
const LeftLegend = () => {
  const {
    originalSeries: series,
    leftLegendHeight,
    innerHeight,
    internalMargin,
    leftLegend,
    setLeftLegend
  } = useContext(ChartContext);
  const [yTransform, setYTransform] = useState(innerHeight / 2 + internalMargin.top);
  useEffect(() => {
    setYTransform(innerHeight / 2 + internalMargin.top - leftLegendHeight / 2);
  }, [innerHeight, internalMargin.top, leftLegend, leftLegendHeight]);
  return /* @__PURE__ */ jsx("g", { transform: `translate(8,${yTransform})`, ref: setLeftLegend, children: series.map((serie, i) => /* @__PURE__ */ jsx("g", { className: "tick", transform: `translate(0,${i * 30})`, children: /* @__PURE__ */ jsx(LegendItem, { domainValue: serie.name }, serie.name) }, serie.name)) });
};
export {
  LeftLegend
};
//# sourceMappingURL=LeftLegend.js.map
