import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useContext } from "react";
import { RightLegend } from "./RightLegend.js";
import { TopLegend } from "./TopLegend.js";
import { ChartContext } from "../../ChartContext.js";
import { BottomLegend } from "./BottomLegend.js";
import { LeftLegend } from "./LeftLegend.js";
const Legend = () => {
  const {
    props: { legend },
    width
  } = useContext(ChartContext);
  if (legend?.position === "top" || legend?.position === "left" && width <= 400) return /* @__PURE__ */ jsx(TopLegend, {});
  if (legend?.position === "bottom" || legend?.position === "right" && width <= 400) return /* @__PURE__ */ jsx(BottomLegend, {});
  if (legend?.position === "right") return /* @__PURE__ */ jsx(RightLegend, {});
  if (legend?.position === "left") return /* @__PURE__ */ jsx(LeftLegend, {});
  return null;
};
export {
  Legend
};
//# sourceMappingURL=Legend.js.map
