import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import { useContext, useState, useEffect } from "react";
import { ChartContext } from "../../ChartContext.js";
import { LegendItem } from "./LegendItem.js";
const RightLegend = () => {
  const {
    innerWidth,
    innerHeight,
    rightLabelWidth,
    axisRightWidth,
    internalMargin,
    rightLegendHeight,
    setRightLegend,
    originalSeries: series
  } = useContext(ChartContext);
  const [yTransform, setYTransform] = useState(innerHeight / 2 + internalMargin.top);
  useEffect(() => {
    setYTransform(innerHeight / 2 + internalMargin.top - rightLegendHeight / 2);
  }, [innerHeight, internalMargin.top, rightLegendHeight]);
  return /* @__PURE__ */ jsxs(
    "g",
    {
      ref: setRightLegend,
      transform: `translate(${innerWidth + internalMargin.left + axisRightWidth + rightLabelWidth},${yTransform})`,
      children: [
        /* @__PURE__ */ jsx("rect", { width: "20", height: 1, fill: "transparent" }),
        /* @__PURE__ */ jsx("g", { transform: "translate(0,0)", children: series.map((serie, i) => /* @__PURE__ */ jsx("g", { className: "tick", transform: `translate(30,${i * 30})`, children: /* @__PURE__ */ jsx(LegendItem, { domainValue: serie.name }) }, serie.name)) })
      ]
    }
  );
};
export {
  RightLegend
};
//# sourceMappingURL=RightLegend.js.map
