import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import { useContext, useCallback, useState } from "react";
import { DSPopperJS } from "@elliemae/ds-popperjs";
import { ThemeContext } from "@elliemae/ds-system";
import { ChartContext } from "../../ChartContext.js";
import { StyledMouseOverDetectionBox, StyledTooltipContainer } from "../../styles.js";
const ScrapperLine = ({ yPosition, datum }) => {
  const {
    scrapperPosY,
    setScrapperPosY,
    innerWidth,
    yScale,
    setActivePoint,
    isGrabbed,
    props: { TooltipRenderer, scrapper }
  } = useContext(ChartContext);
  const theme = useContext(ThemeContext);
  const [referenceElement, setReferenceElement] = useState(null);
  const yPositionString = yPosition;
  const handleOnMouseEnter = useCallback(() => {
    if (!isGrabbed) setScrapperPosY(yPositionString);
    setActivePoint(null);
  }, [isGrabbed, setScrapperPosY, setActivePoint, yPositionString]);
  const strokeDetectorWidth = yScale?.type === "BAND" ? yScale?.getBandwidth() : "4px";
  return /* @__PURE__ */ jsxs("g", { children: [
    scrapperPosY === yPositionString ? /* @__PURE__ */ jsxs("g", { children: [
      TooltipRenderer ? /* @__PURE__ */ jsx("foreignObject", { children: /* @__PURE__ */ jsxs(
        DSPopperJS,
        {
          withoutAnimation: true,
          withoutArrow: true,
          customOffset: [0, 5],
          referenceElement,
          showPopover: true,
          zIndex: theme.zIndex.tooltip,
          startPlacementPreference: scrapper?.tooltipPreference,
          children: [
            /* @__PURE__ */ jsx(StyledMouseOverDetectionBox, {}),
            /* @__PURE__ */ jsx(StyledTooltipContainer, { children: /* @__PURE__ */ jsx(TooltipRenderer, { data: datum }) })
          ]
        }
      ) }) : null,
      /* @__PURE__ */ jsx(
        "line",
        {
          ref: setReferenceElement,
          x1: innerWidth,
          strokeWidth: "2px",
          stroke: "transparent",
          y1: yPosition,
          x2: innerWidth,
          y2: yPosition
        }
      ),
      /* @__PURE__ */ jsx(
        "line",
        {
          x1: 0,
          strokeWidth: "2px",
          stroke: "grey",
          strokeDasharray: "4 4",
          y1: yPosition,
          x2: innerWidth,
          y2: yPosition
        }
      )
    ] }) : null,
    /* @__PURE__ */ jsx(
      "line",
      {
        onMouseEnter: handleOnMouseEnter,
        x1: 0,
        strokeWidth: strokeDetectorWidth,
        stroke: "transparent",
        y1: yPosition,
        x2: innerWidth,
        y2: yPosition
      }
    )
  ] });
};
export {
  ScrapperLine
};
//# sourceMappingURL=ScrapperLine.js.map
