import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useMemo, useContext } from "react";
import { VerticalScrapperLine } from "./VerticalScrapperLine.js";
import { useUniqueData } from "../../helpers/useUniqueData.js";
import { ChartContext } from "../../ChartContext.js";
const VerticalScrapper = () => {
  const uniqueData = useUniqueData();
  const {
    scrapperPosX,
    setScrapperPosX,
    isGrabbed,
    xScale,
    setActivePoint,
    innerHeight,
    props: { TooltipRenderer, scrapper }
  } = useContext(ChartContext);
  return useMemo(
    () => /* @__PURE__ */ jsx("g", { className: "vertical-scrapper", children: scrapper && uniqueData.map((line) => /* @__PURE__ */ jsx(
      VerticalScrapperLine,
      {
        rectDetector: line?.rectDetector,
        xPosition: line.xPosition,
        data: line.dataPerPosition,
        scrapperPosX,
        setScrapperPosX,
        isGrabbed,
        xScale,
        setActivePoint,
        innerHeight,
        TooltipRenderer,
        scrapper
      },
      line.xPosition
    )) }),
    [
      TooltipRenderer,
      innerHeight,
      isGrabbed,
      scrapper,
      scrapperPosX,
      setActivePoint,
      setScrapperPosX,
      uniqueData,
      xScale
    ]
  );
};
export {
  VerticalScrapper
};
//# sourceMappingURL=VerticalScrapper.js.map
