import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import React2, { useContext, useCallback, useState } from "react";
import { DSPopperJS } from "@elliemae/ds-popperjs";
import { ThemeContext } from "@elliemae/ds-system";
import { StyledMouseOverDetectionBox, StyledTooltipContainer } from "../../styles.js";
const VerticalScrapperLine = React2.memo(
  ({
    rectDetector,
    xPosition,
    data,
    scrapperPosX,
    setScrapperPosX,
    isGrabbed,
    xScale,
    setActivePoint,
    innerHeight,
    TooltipRenderer,
    scrapper
  }) => {
    const theme = useContext(ThemeContext);
    const [referenceElement, setReferenceElement] = useState();
    const isActive = scrapperPosX === xPosition;
    const handleOnMouseEnter = useCallback(() => {
      if (!isGrabbed) setScrapperPosX(xPosition);
      setActivePoint(null);
    }, [isGrabbed, setActivePoint, setScrapperPosX, xPosition]);
    const nonNullXscale = xScale ?? { type: "notBANDAndEverythingElseIsCurrentlyTreatedTheSame" };
    return /* @__PURE__ */ jsxs("g", { transform: `translate(${nonNullXscale.type === "BAND" ? nonNullXscale.getBandwidth() / 2 : 0}, 0)`, children: [
      isActive && !isGrabbed ? /* @__PURE__ */ jsxs("g", { children: [
        TooltipRenderer ? /* @__PURE__ */ jsx("foreignObject", { children: /* @__PURE__ */ jsxs(
          DSPopperJS,
          {
            withoutAnimation: true,
            withoutArrow: true,
            customOffset: [0, 5],
            referenceElement,
            showPopover: true,
            zIndex: theme.zIndex.tooltip,
            startPlacementPreference: scrapper.tooltipPreference,
            children: [
              /* @__PURE__ */ jsx(StyledMouseOverDetectionBox, {}),
              /* @__PURE__ */ jsx(StyledTooltipContainer, { children: /* @__PURE__ */ jsx(TooltipRenderer, { data }) })
            ]
          }
        ) }) : null,
        /* @__PURE__ */ jsx(
          "line",
          {
            ref: setReferenceElement,
            x1: xPosition,
            strokeWidth: "2px",
            stroke: scrapper.color,
            y1: 0,
            x2: xPosition,
            y2: innerHeight,
            strokeDasharray: "4 4"
          }
        )
      ] }) : null,
      /* @__PURE__ */ jsx(
        "rect",
        {
          onMouseOver: handleOnMouseEnter,
          x: nonNullXscale.type === "BAND" ? xPosition - nonNullXscale.getBandwidth() / 2 : xPosition - (rectDetector?.left ?? 0),
          fill: "transparent",
          y: 0,
          width: nonNullXscale.type === "BAND" ? nonNullXscale.getBandwidth() : (rectDetector?.right ?? 0) + (rectDetector?.left ?? 0),
          height: innerHeight
        }
      )
    ] });
  }
);
export {
  VerticalScrapperLine
};
//# sourceMappingURL=VerticalScrapperLine.js.map
