import * as React from "react";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { useContext, useMemo } from "react";
import { ChartContext } from "../../ChartContext.js";
const BlurMask = () => {
  const {
    props: { xScroll, yScroll },
    xScrollbarPosition,
    innerWidth,
    internalMargin,
    containerRatio,
    innerHeight,
    chartId,
    height,
    width
  } = useContext(ChartContext);
  const gradient = useMemo(() => {
    if (xScrollbarPosition === 0) {
      return /* @__PURE__ */ jsxs(Fragment, { children: [
        /* @__PURE__ */ jsx("stop", { offset: "93%", style: { stopColor: "white", stopOpacity: 1 } }),
        /* @__PURE__ */ jsx("stop", { offset: "100%", style: { stopColor: "white", stopOpacity: 0 } })
      ] });
    }
    const isAtEndXScroll = innerWidth * containerRatio === (xScrollbarPosition + innerWidth / containerRatio) * containerRatio;
    const isAtEndYScroll = innerHeight * containerRatio === (xScrollbarPosition + innerHeight / containerRatio) * containerRatio;
    if (isAtEndXScroll || isAtEndYScroll) {
      return /* @__PURE__ */ jsxs(Fragment, { children: [
        /* @__PURE__ */ jsx("stop", { offset: "0%", style: { stopColor: "white", stopOpacity: 0 } }),
        /* @__PURE__ */ jsx("stop", { offset: "7%", style: { stopColor: "white", stopOpacity: 1 } })
      ] });
    }
    return /* @__PURE__ */ jsxs(Fragment, { children: [
      /* @__PURE__ */ jsx("stop", { offset: "0%", style: { stopColor: "white", stopOpacity: 0 } }),
      /* @__PURE__ */ jsx("stop", { offset: "7%", style: { stopColor: "white", stopOpacity: 1 } }),
      /* @__PURE__ */ jsx("stop", { offset: "93%", style: { stopColor: "white", stopOpacity: 1 } }),
      /* @__PURE__ */ jsx("stop", { offset: "100%", style: { stopColor: "white", stopOpacity: 0 } })
    ] });
  }, [containerRatio, innerHeight, innerWidth, xScrollbarPosition]);
  return useMemo(() => {
    if (containerRatio === 1) return null;
    if (xScroll && !yScroll) {
      const realWidth = xScrollbarPosition === 0 ? innerWidth + internalMargin.left : innerWidth;
      const realX = xScrollbarPosition === 0 ? -internalMargin.left : 0;
      return /* @__PURE__ */ jsxs("defs", { children: [
        /* @__PURE__ */ jsx("linearGradient", { id: `filter-fade-${chartId}`, children: gradient }),
        /* @__PURE__ */ jsx("mask", { id: `mask-${chartId}`, children: /* @__PURE__ */ jsx("rect", { x: realX, width: realWidth, height, fill: `url(#filter-fade-${chartId}` }) })
      ] });
    }
    if (yScroll && !xScroll) {
      return /* @__PURE__ */ jsxs("defs", { children: [
        /* @__PURE__ */ jsx("linearGradient", { x2: "0%", y2: "100%", id: `filter-fade-${chartId}`, children: gradient }),
        /* @__PURE__ */ jsx("mask", { id: `mask-y-${chartId}`, children: /* @__PURE__ */ jsx(
          "rect",
          {
            x: -internalMargin.left,
            width,
            height: innerHeight,
            fill: `url(#filter-fade-${chartId}`
          }
        ) })
      ] });
    }
    return null;
  }, [
    chartId,
    containerRatio,
    gradient,
    height,
    innerHeight,
    innerWidth,
    internalMargin.left,
    width,
    xScroll,
    xScrollbarPosition,
    yScroll
  ]);
};
export {
  BlurMask
};
//# sourceMappingURL=BlurMask.js.map
