import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import { useContext, useMemo } from "react";
import { ChartContext } from "../../ChartContext.js";
import { SeriesFactory } from "../SeriesFactory.js";
import { ScrollBarY } from "./ScrollBarY.js";
import { Scrapper } from "../Scrapper/Scrapper.js";
import { VerticalScrapper } from "../Scrapper/VerticalScrapper.js";
import { AxisLeft } from "../Axis/AxisLeft.js";
const ScrollableContainerY = () => {
  const {
    props: { scrapper },
    xScrollbarPosition,
    containerRatio,
    chartId
  } = useContext(ChartContext);
  const Scrappers = useMemo(() => {
    if (scrapper?.type === "horizontal") return /* @__PURE__ */ jsx(Scrapper, {});
    if (scrapper?.type === "vertical") return /* @__PURE__ */ jsx(VerticalScrapper, {});
    return null;
  }, [scrapper?.type]);
  return /* @__PURE__ */ jsxs("g", { className: "scrollable-container-y", children: [
    /* @__PURE__ */ jsx("g", { mask: `url(#mask-y-${chartId})`, children: /* @__PURE__ */ jsxs("g", { transform: `translate(0,${-xScrollbarPosition * containerRatio})`, children: [
      /* @__PURE__ */ jsx(SeriesFactory, {}),
      Scrappers,
      /* @__PURE__ */ jsx(AxisLeft, {})
    ] }) }),
    /* @__PURE__ */ jsx(ScrollBarY, {})
  ] });
};
export {
  ScrollableContainerY
};
//# sourceMappingURL=ScrollableContainerY.js.map
