import * as React from "react";
import { jsx } from "react/jsx-runtime";
import { useContext } from "react";
import { ChartContext } from "../ChartContext.js";
const TrendHighlight = ({ currentDatum }) => {
  const { currentData, getXScaleValue, getY2ScaleValue, getYScaleValue } = useContext(ChartContext);
  const prevPoint = currentData?.find((serie) => serie.name === currentDatum.serie && serie.type === "line")?.data?.find((datum) => datum.position === currentDatum.position - 1);
  const currentYScale = prevPoint?.scale === "y2" ? getY2ScaleValue : getYScaleValue;
  if (!prevPoint) return null;
  const xCurrentPosition = getXScaleValue(currentDatum);
  const yCurrentPosition = currentYScale(currentDatum);
  const xPreviousPosition = getXScaleValue(prevPoint);
  const yPreviousPosition = currentYScale(prevPoint);
  return /* @__PURE__ */ jsx(
    "line",
    {
      strokeWidth: "4",
      stroke: (yPreviousPosition ?? 0) > (yCurrentPosition ?? 0) ? "green" : "red",
      x1: xPreviousPosition,
      x2: xCurrentPosition,
      y1: yPreviousPosition,
      y2: yCurrentPosition
    }
  );
};
export {
  TrendHighlight
};
//# sourceMappingURL=TrendHighlight.js.map
