import * as React from "react";
import { styled } from "@elliemae/ds-system";
const StyledSVGWrapper = styled.div`
  rect:focus,
  rect:focus-visible,
  circle:focus,
  circle:focus-visible {
    outline: none;
  }

  :focus,
  :focus-visible {
    outline: none;
  }

  cursor: ${({ isGrabbed }) => isGrabbed ? "grabbing" : "default"};

  text {
    font-size: 1rem;
  }

  min-width: 300px;
`;
const StyledAxis = styled("line")`
  stroke-width: 2px;
  stroke: ${({ theme }) => theme.colors.neutral["700"]};
  ${({ axisColor }) => axisColor ? `stroke: ${axisColor}` : ""}
`;
const StyledAxisLabel = styled("text")`
  font-size: 1rem;
  font-weight: 600;
`;
const StyledGrid = styled("g")`
  line {
    opacity: 0.2;
  }
`;
const StyleFocusableRegion = styled.div`
  width: ${({ size = 1 }) => size * 2}px;
  height: ${({ size = 1 }) => size * 2}px;
  outline: none;
  &:focus {
    outline: none;
  }
`;
const StyledLine = styled("path")`
  fill: none;
  stroke-width: 3;
  stroke-linejoin: round;
`;
const StyledArea = styled("path")`
  stroke-width: 3;
  stroke-linejoin: round;
  opacity: 0.2;
`;
const StyledTooltipContainer = styled.div`
  max-width: 350px;
  background-color: white;
`;
const StyledMouseOverDetectionBox = styled.div`
  position: absolute;
  top: -15px;
  right: -15px;
  width: calc(100% + 30px);
  height: calc(100% + 30px);
  z-index: -1;
`;
export {
  StyleFocusableRegion,
  StyledArea,
  StyledAxis,
  StyledAxisLabel,
  StyledGrid,
  StyledLine,
  StyledMouseOverDetectionBox,
  StyledSVGWrapper,
  StyledTooltipContainer
};
//# sourceMappingURL=styles.js.map
