import * as React from "react";
import { curveLinear, curveMonotoneX, timeDay, timeMonth, timeHour, timeMinute, timeWeek } from "d3";
const SCALE_TYPES = {
  LINEAR: "linear",
  BAND: "band",
  LOG: "log",
  TIME: "time"
};
const FOCUS_RING = {
  COLOR: "#335cad",
  STROKE_WIDTH: 2,
  OFFSET: 4
};
const SERIE_TYPES = { LINE: "line", BAR: "bar", AREA: "area", POINT: "point" };
const SCRAPPER = {
  TYPE_HORIZONTAL: "horizontal",
  TYPE_VERTICAL: "vertical"
};
const LINE = {
  POINT_STYLE: {
    CIRCLE: "CIRCLE",
    SQUARE: "SQUARE",
    DIAMOND: "DIAMOND"
  },
  DEFAULT_POINT_RADIUS: 4,
  DASH_STYLE: {
    SHORTDOT: "SHORTDOT",
    SHORTDASHDOT: "SHORTDASHDOT",
    DASH: "DASH",
    SHORTDASH: "SHORTDASH"
  },
  DASH_STYLE_VALUES: {
    SHORTDOT: [2, 2],
    SHORTDASHDOT: [6, 2, 2, 2],
    DASH: [8, 6],
    SHORTDASH: [6, 2]
  },
  CURVE_STYLE: {
    LINEAR: "LINEAR",
    SPLINE: "SPLINE"
  }
};
const curveStyleMap = {
  [LINE.CURVE_STYLE.LINEAR]: curveLinear,
  [LINE.CURVE_STYLE.SPLINE]: curveMonotoneX
};
const TOOLBAR = {
  RESET: {
    HEIGHT: 21,
    WIDTH: 21
  }
};
const TIME_OFFSET = {
  HOUR: timeHour,
  MINUTE: timeMinute,
  WEEK: timeWeek,
  DAY: timeDay,
  MONTH: timeMonth
};
export {
  FOCUS_RING,
  LINE,
  SCALE_TYPES,
  SCRAPPER,
  SERIE_TYPES,
  TIME_OFFSET,
  TOOLBAR,
  curveStyleMap
};
//# sourceMappingURL=constants.js.map
