import type React from 'react';
import type { ScaleBand, ScaleOrdinal } from 'd3';
import type { DSChartT } from './react-desc-prop-types.js';
import type { ScaleT } from './scales/index.js';
interface ContextT {
    props: DSChartT.Props;
    originalSeries: DSChartT.SeriesT[];
    currentData: DSChartT.InternalData;
    currentDataWithNullValues: DSChartT.InternalData;
    xScale: ScaleT | null;
    yScale: ScaleT | null;
    y2Scale: ScaleT | null;
    innerHeight: number;
    innerWidth: number;
    activePoint: DSChartT.InternalDatum | null;
    containerRef: HTMLDivElement | null;
    setContainerRef: React.Dispatch<React.SetStateAction<HTMLDivElement | null>>;
    groups: string[];
    subGroupScale?: ScaleBand<string> | null;
    colorScale: ScaleOrdinal<string, unknown, string>;
    axisLeftRef: SVGGElement | null;
    scrapperPosY: number;
    scrapperPosX: number;
    xScrollbarPosition: number;
    isGrabbed: boolean;
    startPosition: number;
    isScrollbarVisible: boolean;
    lastScrollbarPosition: React.MutableRefObject<number>;
    containerRatio: number;
    internalMargin: {
        bottom: number;
        top: number;
        right: number;
        left: number;
    };
    toolbarHeight: number;
    leftLegendHeight: number;
    rightLegendHeight: number;
    leftLabelHeight: number;
    leftLegendWidth: number;
    leftLabelWidth: number;
    leftLegend: SVGGElement | null;
    bottomLegend: SVGGElement | null;
    rightLegend: SVGGElement | null;
    axisBottomHeight: number;
    bottomLabelHeight: number;
    rightLabelWidth: number;
    axisRightWidth: number;
    isHorizontal: boolean;
    leftLabel: SVGGElement | null;
    chartId: string;
    hiddenSeries: string[];
    stackedData: DSChartT.StackedSeriesByGroupT;
    width: number;
    height: number;
    isZooming: boolean;
    zoomStartingPosition: number;
    movingPosition: number;
    axisLeftWidth: number;
    bottomLegendWidth: number;
    setActivePoint: React.Dispatch<React.SetStateAction<DSChartT.InternalDatum | null>>;
    getBandwidth: () => number;
    setScrapperPosY: React.Dispatch<React.SetStateAction<number>>;
    setScrapperPosX: React.Dispatch<React.SetStateAction<number>>;
    setXScrollbarPosition: React.Dispatch<React.SetStateAction<number>>;
    setIsGrabbed: React.Dispatch<React.SetStateAction<boolean>>;
    setStartPosition: React.Dispatch<React.SetStateAction<number>>;
    setIsScrollbarVisible: React.Dispatch<React.SetStateAction<boolean>>;
    setAxisLeftRef: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setLeftLegend: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setRightLegend: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setTopLegend: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setBottomLegend: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setAxisBottomRef: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setLeftLabel: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setAxisRightRef: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setRightLabel: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setBottomLabel: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    getXValue: (datum: DSChartT.InternalDatum) => string | number | Date | null;
    getYValue: (datum: DSChartT.InternalDatum) => string | number | Date | null;
    getXValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
    getYValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
    setHiddenSeries: React.Dispatch<React.SetStateAction<string[]>>;
    getXScaleValue: (datum: DSChartT.InternalDatum | number) => number;
    getYScaleValue: (datum: DSChartT.InternalDatum | number) => number;
    getY2ScaleValue: (datum: DSChartT.InternalDatum | number) => number;
    setContainerRatio: React.Dispatch<React.SetStateAction<number>>;
    setToolbarRef: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    setMovingPosition: React.Dispatch<React.SetStateAction<number>>;
    setIsZooming: React.Dispatch<React.SetStateAction<boolean>>;
    setZoomStartingPosition: React.Dispatch<React.SetStateAction<number>>;
}
export declare const ChartContext: React.Context<ContextT>;
export {};
