/// <reference types="react" />
import type { GlobalAttributesT, XstyledProps, DSPropTypesSchema } from '@elliemae/ds-props-helpers';
import { type BackgroundProps, type BorderProps } from '@elliemae/ds-system';
export declare namespace DSSingleStackedBarT {
    type DatumT = {
        name: string;
        data: number;
        color: string;
    };
    type SingleStackedBarDatumT = DatumT[];
    type TooltipRenderDataT = {
        datum: DatumT;
    };
    interface SingleStackedBarT {
        data: SingleStackedBarDatumT;
        TooltipRenderer?: React.ComponentType<TooltipRenderDataT>;
        LegendRenderer?: React.ComponentType<TooltipRenderDataT>;
        height: string | number;
        gutter?: string | number;
    }
    interface BarT extends SingleStackedBarT {
        isFocused: boolean;
        borderRadius?: BorderProps['borderRadius'];
        bg: BackgroundProps['bg'];
        tabIndex?: 0 | -1;
        datum: DatumT;
    }
    interface RequiredProps {
        height: string | number;
        data: DatumT[];
    }
    interface DefaultProps {
        gutter: string;
    }
    interface OptionalProps {
        TooltipRenderer?: React.ComponentType<TooltipRenderDataT>;
        LegendRenderer?: React.ComponentType<TooltipRenderDataT>;
    }
    interface Props extends Partial<DefaultProps>, OptionalProps, Omit<GlobalAttributesT<HTMLButtonElement>, keyof DefaultProps | keyof OptionalProps | keyof RequiredProps>, XstyledProps, RequiredProps {
    }
    interface InternalProps extends DefaultProps, OptionalProps, Omit<GlobalAttributesT<HTMLButtonElement>, keyof DefaultProps | keyof OptionalProps | keyof RequiredProps>, XstyledProps, RequiredProps {
    }
}
export declare const defaultProps: DSSingleStackedBarT.DefaultProps;
export declare const DSSingleStackedBarPropTypes: DSPropTypesSchema<DSSingleStackedBarT.Props>;
