/// <reference types="react" />
import type { DSChartT } from '../react-desc-prop-types.js';
export declare const useChart: (props: DSChartT.Props) => {
    props: DSChartT.Props;
    originalSeries: DSChartT.SeriesT[];
    isZooming: boolean;
    setIsZooming: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    zoomStartingPosition: number;
    setZoomStartingPosition: import("react").Dispatch<import("react").SetStateAction<number>>;
    setMovingPosition: import("react").Dispatch<import("react").SetStateAction<number>>;
    movingPosition: number;
    innerHeight: number;
    innerWidth: number;
    groups: string[];
    currentData: {
        data: DSChartT.InternalDatum[];
        key: string;
        name: string;
        type: DSChartT.SeriesTypes;
        scale?: string | undefined;
        color: string;
        dashStyle?: string | undefined;
        pointRadius?: number | undefined;
        pointStyle?: string | undefined;
        curveStyle?: string | undefined;
    }[];
    colorScale: import("d3-scale").ScaleOrdinal<string, unknown, string>;
    stackedData: DSChartT.StackedSeriesByGroupT;
    subGroupScale: import("d3-scale").ScaleBand<string> | null;
    xScale: import("../scales/index.js").BandScale | import("../scales/index.js").LinearScale | import("../scales/index.js").TimeLinearScale | null;
    yScale: import("../scales/index.js").BandScale | import("../scales/index.js").LinearScale | import("../scales/index.js").TimeLinearScale | null;
    y2Scale: import("../scales/index.js").BandScale | import("../scales/index.js").LinearScale | import("../scales/index.js").TimeLinearScale | null;
    containerRef: HTMLDivElement | null;
    getBandwidth: () => number;
    scrapperPosY: number;
    setScrapperPosY: import("react").Dispatch<import("react").SetStateAction<number>>;
    scrapperPosX: number;
    setScrapperPosX: import("react").Dispatch<import("react").SetStateAction<number>>;
    activePoint: DSChartT.InternalDatum | null;
    setActivePoint: import("react").Dispatch<import("react").SetStateAction<DSChartT.InternalDatum | null>>;
    activeSerie: string;
    setActiveSerie: import("react").Dispatch<import("react").SetStateAction<string>>;
    xScrollbarPosition: number;
    setXScrollbarPosition: import("react").Dispatch<import("react").SetStateAction<number>>;
    isGrabbed: boolean;
    setIsGrabbed: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    setContainerRef: import("react").Dispatch<import("react").SetStateAction<HTMLDivElement | null>>;
    startPosition: number;
    setStartPosition: import("react").Dispatch<import("react").SetStateAction<number>>;
    isScrollbarVisible: boolean;
    setIsScrollbarVisible: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    lastScrollbarPosition: import("react").MutableRefObject<number>;
    containerRatio: number;
    internalMargin: {
        bottom: number;
        top: number;
        right: number;
        left: number;
    };
    axisLeftRef: SVGGElement | null;
    leftLegendWidth: number;
    leftLegend: SVGGElement | null;
    setAxisLeftRef: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setLeftLegend: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setRightLegend: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    rightLegend: SVGGElement | null;
    setTopLegend: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setBottomLegend: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setAxisBottomRef: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    axisBottomHeight: number;
    setAxisRightRef: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setRightLabel: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    setBottomLabel: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    getXScaleValue: (datum: DSChartT.InternalDatum | (string | number | Date)) => number;
    getYScaleValue: (datum: DSChartT.InternalDatum | (string | number | Date)) => number;
    getY2ScaleValue: (datum: DSChartT.InternalDatum | (string | number | Date)) => number;
    getYValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
    getXValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
    bottomLabelHeight: number;
    rightLabelWidth: number;
    axisRightWidth: number;
    getXValue: (datum: DSChartT.InternalDatum) => string | number | null;
    getYValue: (datum: DSChartT.InternalDatum) => string | number | null;
    isHorizontal: boolean;
    setLeftLabel: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    leftLabel: SVGGElement | null;
    chartId: string;
    hiddenSeries: string[];
    setHiddenSeries: import("react").Dispatch<import("react").SetStateAction<string[]>>;
    height: number;
    width: number;
    setContainerRatio: import("react").Dispatch<import("react").SetStateAction<number>>;
    toolbarHeight: number;
    setToolbarRef: import("react").Dispatch<import("react").SetStateAction<SVGGElement | null>>;
    leftLabelHeight: number;
    rightLegendHeight: number;
    bottomLegendWidth: number;
    bottomLegend: SVGGElement | null;
    leftLabelWidth: number;
    axisLeftWidth: number;
    topLegendHeight: number;
    leftLegendHeight: number;
    currentDataWithNullValues: DSChartT.InternalData;
};
