import type { DSChartT } from '../react-desc-prop-types.js';
import type { TimeLinearScale, LinearScale, BandScale } from '../scales/index.js';
interface UseGettersT {
    xAxis: DSChartT.AxisT;
    yAxis: DSChartT.AxisT;
    isHorizontal: boolean;
    xScale: TimeLinearScale | LinearScale | BandScale | null;
    yScale: TimeLinearScale | LinearScale | BandScale | null;
    y2Scale: TimeLinearScale | LinearScale | BandScale | null;
}
type ValueT = number | string | Date;
export declare const useGetters: ({ xAxis, isHorizontal, yAxis, xScale, yScale, y2Scale }: UseGettersT) => {
    getYValue: (datum: DSChartT.InternalDatum) => string | number | null;
    getY2ScaleValue: (datum: DSChartT.InternalDatum | ValueT) => number;
    getXValue: (datum: DSChartT.InternalDatum) => string | number | null;
    getXScaleValue: (datum: DSChartT.InternalDatum | ValueT) => number;
    getYScaleValue: (datum: DSChartT.InternalDatum | ValueT) => number;
    getYValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
    getXValueFormatted: (datum: DSChartT.InternalDatum) => string | number | null;
};
export {};
