import type { Series } from 'd3';
import type { DSChartT } from '../react-desc-prop-types.js';
import { BandScale, LinearScale, TimeLinearScale } from '../scales/index.js';
interface UseScales {
    props: DSChartT.Props;
    innerHeight: number;
    innerWidth: number;
    originalSeries: DSChartT.SeriesT[];
    stackedData: Series<{
        [key: string]: number;
    }, string>[][];
    currentData: DSChartT.InternalData;
    groups: string[];
    containerRatio: number;
    scalesStackedDataMap: string[];
}
export declare const useScales: ({ props, originalSeries: series, innerHeight, innerWidth, stackedData, currentData, scalesStackedDataMap, containerRatio, }: UseScales) => {
    xScale: BandScale | LinearScale | TimeLinearScale | null;
    y2Scale: BandScale | LinearScale | TimeLinearScale | null;
    yScale: BandScale | LinearScale | TimeLinearScale | null;
    subGroupScale: import("d3-scale").ScaleBand<string> | null;
    colorScale: import("d3-scale").ScaleOrdinal<string, unknown, string>;
    getBandwidth: () => number;
};
export {};
