import React from 'react';
import type { ScaleT } from '../../scales/index.js';
import { type DSChartT } from '../../react-desc-prop-types.js';
export interface TickRenderPropsT {
    position: number;
    tickValue: string | number | Date;
}
export interface GridRenderPropsT {
    position: number;
    tickValue: string | number | Date;
}
interface AxisT<S extends ScaleT> {
    lineCoords: {
        x1: number;
        x2: number;
        y1: number;
        y2: number;
    };
    innerRef: React.Dispatch<React.SetStateAction<SVGGElement | null>>;
    scale: S | null;
    dimension: number;
    intervalType?: DSChartT.IntervalT;
    TickRenderer: (props: TickRenderPropsT) => JSX.Element | null;
    GridRenderer: (props: GridRenderPropsT) => JSX.Element | null;
    color: string;
}
export declare const Axis: React.MemoExoticComponent<(<S extends ScaleT>(props: AxisT<S>) => import("react/jsx-runtime.js").JSX.Element | null)>;
export {};
