export declare const SCALE_TYPES: {
    LINEAR: string;
    BAND: string;
    LOG: string;
    TIME: string;
};
export declare const FOCUS_RING: {
    COLOR: string;
    STROKE_WIDTH: number;
    OFFSET: number;
};
export declare const SERIE_TYPES: {
    readonly LINE: "line";
    readonly BAR: "bar";
    readonly AREA: "area";
    readonly POINT: "point";
};
export declare const SCRAPPER: {
    TYPE_HORIZONTAL: string;
    TYPE_VERTICAL: string;
};
export declare const LINE: {
    POINT_STYLE: {
        CIRCLE: string;
        SQUARE: string;
        DIAMOND: string;
    };
    DEFAULT_POINT_RADIUS: number;
    DASH_STYLE: {
        SHORTDOT: string;
        SHORTDASHDOT: string;
        DASH: string;
        SHORTDASH: string;
    };
    DASH_STYLE_VALUES: {
        SHORTDOT: number[];
        SHORTDASHDOT: number[];
        DASH: number[];
        SHORTDASH: number[];
    };
    CURVE_STYLE: {
        LINEAR: string;
        SPLINE: string;
    };
};
export declare const curveStyleMap: {
    [x: string]: import("d3-shape").CurveFactory;
};
export declare const TOOLBAR: {
    RESET: {
        HEIGHT: number;
        WIDTH: number;
    };
};
export declare const TIME_OFFSET: Record<string, d3.CountableTimeInterval>;
